# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

import sys
import os
if os.name == 'nt':
    
    def find_library(name):
        for directory in os.environ['PATH'].split(os.pathsep):
            fname = os.path.join(directory, name)
            if os.path.exists(fname):
                return fname
            
            if fname.lower().endswith('.dll'):
                continue
            
            fname = fname + '.dll'
            if os.path.exists(fname):
                return fname
                continue
        


if os.name == 'ce':
    
    def find_library(name):
        return name


if os.name == 'posix' and sys.platform == 'darwin':
    from ctypes.macholib.dyld import dyld_find as _dyld_find
    
    def find_library(name):
        possible = [
            'lib%s.dylib' % name,
            '%s.dylib' % name,
            '%s.framework/%s' % (name, name)]
        for name in possible:
            
            try:
                return _dyld_find(name)
            continue
            except ValueError:
                continue
                continue
            

        

elif os.name == 'posix':
    import re
    import tempfile
    import errno
    
    def _findLib_gcc(name):
        expr = '[^\\(\\)\\s]*lib%s\\.[^\\(\\)\\s]*' % re.escape(name)
        (fdout, ccout) = tempfile.mkstemp()
        os.close(fdout)
        cmd = 'if type gcc >/dev/null 2>&1; then CC=gcc; else CC=cc; fi;$CC -Wl,-t -o ' + ccout + ' 2>&1 -l' + name
        
        try:
            f = os.popen(cmd)
            trace = f.read()
            f.close()
        finally:
            
            try:
                os.unlink(ccout)
            except OSError:
                e = None
                if e.errno != errno.ENOENT:
                    raise 
                
            except:
                e.errno != errno.ENOENT


        res = re.search(expr, trace)
        if not res:
            return None
        
        return res.group(0)

    if sys.platform == 'sunos5':
        
        def _get_soname(f):
            if not f:
                return None
            
            cmd = '/usr/ccs/bin/dump -Lpv 2>/dev/null ' + f
            res = re.search('\\[.*\\]\\sSONAME\\s+([^\\s]+)', os.popen(cmd).read())
            if not res:
                return None
            
            return res.group(1)

    else:
        
        def _get_soname(f):
            if not f:
                return None
            
            cmd = 'objdump -p -j .dynamic 2>/dev/null ' + f
            res = re.search('\\sSONAME\\s+([^\\s]+)', os.popen(cmd).read())
            if not res:
                return None
            
            return res.group(1)

    if sys.platform.startswith('freebsd') and sys.platform.startswith('openbsd') or sys.platform.startswith('dragonfly'):
        
        def _num_version(libname):
            parts = libname.split('.')
            nums = []
            
            try:
                while parts:
                    nums.insert(0, int(parts.pop()))
            except ValueError:
                pass

            if not nums:
                pass
            return [
                sys.maxint]

        
        def find_library(name):
            ename = re.escape(name)
            expr = ':-l%s\\.\\S+ => \\S*/(lib%s\\.\\S+)' % (ename, ename)
            res = re.findall(expr, os.popen('/sbin/ldconfig -r 2>/dev/null').read())
            if not res:
                return _get_soname(_findLib_gcc(name))
            
            res.sort(cmp = (lambda x, y: cmp(_num_version(x), _num_version(y))))
            return res[-1]

    else:
        
        def _findLib_ldconfig(name):
            expr = '/[^\\(\\)\\s]*lib%s\\.[^\\(\\)\\s]*' % re.escape(name)
            res = re.search(expr, os.popen('/sbin/ldconfig -p 2>/dev/null').read())
            if not res:
                cmd = 'ldd %s 2>/dev/null' % sys.executable
                res = re.search(expr, os.popen(cmd).read())
                if not res:
                    return None
                
            
            return res.group(0)

        
        def find_library(name):
            if not _findLib_ldconfig(name):
                pass
            return _get_soname(_findLib_gcc(name))



def test():
    cdll = cdll
    import ctypes
    if os.name == 'nt':
        print cdll.msvcrt
        print cdll.load('msvcrt')
        print find_library('msvcrt')
    
    if os.name == 'posix':
        print find_library('m')
        print find_library('c')
        print find_library('bz2')
        if sys.platform == 'darwin':
            print cdll.LoadLibrary('libm.dylib')
            print cdll.LoadLibrary('libcrypto.dylib')
            print cdll.LoadLibrary('libSystem.dylib')
            print cdll.LoadLibrary('System.framework/System')
        else:
            print cdll.LoadLibrary('libm.so')
            print cdll.LoadLibrary('libcrypt.so')
            print find_library('crypt')
    

if __name__ == '__main__':
    test()

