# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

import sys
import os
import re
import imp
from itertools import count
from Tkinter import *
import tkSimpleDialog
import tkMessageBox
from MultiCall import MultiCallCreator
import webbrowser
import idlever
import WindowList
import SearchDialog
import GrepDialog
import ReplaceDialog
import PyParse
from configHandler import idleConf
import aboutDialog
import textView
import configDialog
import macosxSupport
TK_TABWIDTH_DEFAULT = 8

def _find_module(fullname, path = None):
    '''Version of imp.find_module() that handles hierarchical module names'''
    file = None
    for tgt in fullname.split('.'):
        if file is not None:
            file.close()
        
        (file, filename, descr) = imp.find_module(tgt, path)
        if descr[2] == imp.PY_SOURCE:
            break
        
        module = imp.load_module(tgt, file, filename, descr)
        
        try:
            path = module.__path__
        continue
        except AttributeError:
            raise ImportError, 'No source for module ' + module.__name__
            continue
        

    
    return (file, filename, descr)


class EditorWindow(object):
    from Percolator import Percolator
    from ColorDelegator import ColorDelegator
    from UndoDelegator import UndoDelegator
    from IOBinding import IOBinding, filesystemencoding, encoding
    import Bindings
    from Tkinter import Toplevel
    from MultiStatusBar import MultiStatusBar
    help_url = None
    
    def __init__(self, flist = None, filename = None, key = None, root = None):
        if EditorWindow.help_url is None:
            dochome = os.path.join(sys.prefix, 'Doc', 'index.html')
            if sys.platform.count('linux'):
                pyver = 'python-docs-' + '%s.%s.%s' % sys.version_info[:3]
                if os.path.isdir('/var/www/html/python/'):
                    dochome = '/var/www/html/python/index.html'
                else:
                    basepath = '/usr/share/doc/'
                    dochome = os.path.join(basepath, pyver, 'Doc', 'index.html')
            elif sys.platform[:3] == 'win':
                chmfile = os.path.join(sys.prefix, 'Doc', 'Python%d%d.chm' % sys.version_info[:2])
                if os.path.isfile(chmfile):
                    dochome = chmfile
                
            elif macosxSupport.runningAsOSXApp():
                dochome = os.path.join(sys.prefix, 'Resources/English.lproj/Documentation/index.html')
            
            dochome = os.path.normpath(dochome)
            if os.path.isfile(dochome):
                EditorWindow.help_url = dochome
                if sys.platform == 'darwin':
                    EditorWindow.help_url = 'file://' + EditorWindow.help_url
                
            else:
                EditorWindow.help_url = 'http://www.python.org/doc/current'
        
        currentTheme = idleConf.CurrentTheme()
        self.flist = flist
        if not root:
            pass
        root = flist.root
        self.root = root
        
        try:
            sys.ps1
        except AttributeError:
            sys.ps1 = '>>> '

        self.menubar = Menu(root)
        self.top = top = WindowList.ListedToplevel(root, menu = self.menubar)
        if flist:
            self.tkinter_vars = flist.vars
            self.top.instance_dict = flist.inversedict
        else:
            self.tkinter_vars = { }
            self.top.instance_dict = { }
        self.recent_files_path = os.path.join(idleConf.GetUserCfgDir(), 'recent-files.lst')
        self.vbar = vbar = Scrollbar(top, name = 'vbar')
        self.text_frame = text_frame = Frame(top)
        self.width = idleConf.GetOption('main', 'EditorWindow', 'width')
        self.text = text = MultiCallCreator(Text)(text_frame, name = 'text', padx = 5, wrap = 'none', foreground = idleConf.GetHighlight(currentTheme, 'normal', fgBg = 'fg'), background = idleConf.GetHighlight(currentTheme, 'normal', fgBg = 'bg'), highlightcolor = idleConf.GetHighlight(currentTheme, 'hilite', fgBg = 'fg'), highlightbackground = idleConf.GetHighlight(currentTheme, 'hilite', fgBg = 'bg'), insertbackground = idleConf.GetHighlight(currentTheme, 'cursor', fgBg = 'fg'), width = self.width, height = idleConf.GetOption('main', 'EditorWindow', 'height'))
        self.top.focused_widget = self.text
        self.createmenubar()
        self.apply_bindings()
        self.top.protocol('WM_DELETE_WINDOW', self.close)
        self.top.bind('<<close-window>>', self.close_event)
        if macosxSupport.runningAsOSXApp():
            text.bind('<<close-window>>', self.close_event)
        
        text.bind('<<cut>>', self.cut)
        text.bind('<<copy>>', self.copy)
        text.bind('<<paste>>', self.paste)
        text.bind('<<center-insert>>', self.center_insert_event)
        text.bind('<<help>>', self.help_dialog)
        text.bind('<<python-docs>>', self.python_docs)
        text.bind('<<about-idle>>', self.about_dialog)
        text.bind('<<open-config-dialog>>', self.config_dialog)
        text.bind('<<open-module>>', self.open_module)
        text.bind('<<do-nothing>>', (lambda event: 'break'))
        text.bind('<<select-all>>', self.select_all)
        text.bind('<<remove-selection>>', self.remove_selection)
        text.bind('<<find>>', self.find_event)
        text.bind('<<find-again>>', self.find_again_event)
        text.bind('<<find-in-files>>', self.find_in_files_event)
        text.bind('<<find-selection>>', self.find_selection_event)
        text.bind('<<replace>>', self.replace_event)
        text.bind('<<goto-line>>', self.goto_line_event)
        text.bind('<3>', self.right_menu_event)
        text.bind('<<smart-backspace>>', self.smart_backspace_event)
        text.bind('<<newline-and-indent>>', self.newline_and_indent_event)
        text.bind('<<smart-indent>>', self.smart_indent_event)
        text.bind('<<indent-region>>', self.indent_region_event)
        text.bind('<<dedent-region>>', self.dedent_region_event)
        text.bind('<<comment-region>>', self.comment_region_event)
        text.bind('<<uncomment-region>>', self.uncomment_region_event)
        text.bind('<<tabify-region>>', self.tabify_region_event)
        text.bind('<<untabify-region>>', self.untabify_region_event)
        text.bind('<<toggle-tabs>>', self.toggle_tabs_event)
        text.bind('<<change-indentwidth>>', self.change_indentwidth_event)
        text.bind('<Left>', self.move_at_edge_if_selection(0))
        text.bind('<Right>', self.move_at_edge_if_selection(1))
        text.bind('<<del-word-left>>', self.del_word_left)
        text.bind('<<del-word-right>>', self.del_word_right)
        if flist:
            flist.inversedict[self] = key
            if key:
                flist.dict[key] = self
            
            text.bind('<<open-new-window>>', self.new_callback)
            text.bind('<<close-all-windows>>', self.flist.close_all_callback)
            text.bind('<<open-class-browser>>', self.open_class_browser)
            text.bind('<<open-path-browser>>', self.open_path_browser)
        
        self.set_status_bar()
        vbar['command'] = text.yview
        vbar.pack(side = RIGHT, fill = Y)
        text['yscrollcommand'] = vbar.set
        fontWeight = 'normal'
        if idleConf.GetOption('main', 'EditorWindow', 'font-bold', type = 'bool'):
            fontWeight = 'bold'
        
        text.config(font = (idleConf.GetOption('main', 'EditorWindow', 'font'), idleConf.GetOption('main', 'EditorWindow', 'font-size'), fontWeight))
        text_frame.pack(side = LEFT, fill = BOTH, expand = 1)
        text.pack(side = TOP, fill = BOTH, expand = 1)
        text.focus_set()
        usespaces = idleConf.GetOption('main', 'Indent', 'use-spaces', type = 'bool')
        self.usetabs = not usespaces
        self.tabwidth = 8
        self.indentwidth = self.tabwidth
        self.set_notabs_indentwidth()
        self.context_use_ps1 = False
        self.num_context_lines = (50, 500, 5000000)
        self.per = per = self.Percolator(text)
        if self.ispythonsource(filename):
            self.color = color = self.ColorDelegator()
            per.insertfilter(color)
        else:
            self.color = None
        self.undo = undo = self.UndoDelegator()
        per.insertfilter(undo)
        text.undo_block_start = undo.undo_block_start
        text.undo_block_stop = undo.undo_block_stop
        undo.set_saved_change_hook(self.saved_change_hook)
        self.io = io = self.IOBinding(self)
        io.set_filename_change_hook(self.filename_change_hook)
        self.recent_files_menu = Menu(self.menubar)
        self.menudict['file'].insert_cascade(3, label = 'Recent Files', underline = 0, menu = self.recent_files_menu)
        self.update_recent_files_list()
        if filename:
            if os.path.exists(filename) and not os.path.isdir(filename):
                io.loadfile(filename)
            else:
                io.set_filename(filename)
        
        self.saved_change_hook()
        self.set_indentation_params(self.ispythonsource(filename))
        self.load_extensions()
        menu = self.menudict.get('windows')
        if menu:
            end = menu.index('end')
            if end is None:
                end = -1
            
            if end >= 0:
                menu.add_separator()
                end = end + 1
            
            self.wmenu_end = end
            WindowList.register_callback(self.postwindowsmenu)
        
        self.askyesno = tkMessageBox.askyesno
        self.askinteger = tkSimpleDialog.askinteger
        self.showerror = tkMessageBox.showerror

    
    def _filename_to_unicode(self, filename):
        '''convert filename to unicode in order to display it in Tk'''
        if isinstance(filename, unicode) or not filename:
            return filename
        else:
            
            try:
                return filename.decode(self.filesystemencoding)
            except UnicodeDecodeError:
                
                try:
                    return filename.decode(self.encoding)
                except UnicodeDecodeError:
                    return filename.decode('iso8859-1')
                except:
                    None<EXCEPTION MATCH>UnicodeDecodeError
                

                None<EXCEPTION MATCH>UnicodeDecodeError


    
    def new_callback(self, event):
        (dirname, basename) = self.io.defaultfilename()
        self.flist.new(dirname)
        return 'break'

    
    def set_status_bar(self):
        self.status_bar = self.MultiStatusBar(self.top)
        if macosxSupport.runningAsOSXApp():
            self.status_bar.set_label('_padding1', '    ', side = RIGHT)
        
        self.status_bar.set_label('column', 'Col: ?', side = RIGHT)
        self.status_bar.set_label('line', 'Ln: ?', side = RIGHT)
        self.status_bar.pack(side = BOTTOM, fill = X)
        self.text.bind('<<set-line-and-column>>', self.set_line_and_column)
        self.text.event_add('<<set-line-and-column>>', '<KeyRelease>', '<ButtonRelease>')
        self.text.after_idle(self.set_line_and_column)

    
    def set_line_and_column(self, event = None):
        (line, column) = self.text.index(INSERT).split('.')
        self.status_bar.set_label('column', 'Col: %s' % column)
        self.status_bar.set_label('line', 'Ln: %s' % line)

    menu_specs = [
        ('file', '_File'),
        ('edit', '_Edit'),
        ('format', 'F_ormat'),
        ('run', '_Run'),
        ('options', '_Options'),
        ('windows', '_Windows'),
        ('help', '_Help')]
    if macosxSupport.runningAsOSXApp():
        del menu_specs[-3]
        menu_specs[-2] = ('windows', '_Window')
    
    
    def createmenubar(self):
        mbar = self.menubar
        self.menudict = menudict = { }
        for name, label in self.menu_specs:
            (underline, label) = prepstr(label)
            menudict[name] = menu = Menu(mbar, name = name)
            mbar.add_cascade(label = label, menu = menu, underline = underline)
        
        if sys.platform == 'darwin' and '.framework' in sys.executable:
            menudict['application'] = menu = Menu(mbar, name = 'apple')
            mbar.add_cascade(label = 'IDLE', menu = menu)
        
        self.fill_menus()
        self.base_helpmenu_length = self.menudict['help'].index(END)
        self.reset_help_menu_entries()

    
    def postwindowsmenu(self):
        menu = self.menudict['windows']
        end = menu.index('end')
        if end is None:
            end = -1
        
        if end > self.wmenu_end:
            menu.delete(self.wmenu_end + 1, end)
        
        WindowList.add_windows_to_menu(menu)

    rmenu = None
    
    def right_menu_event(self, event):
        self.text.tag_remove('sel', '1.0', 'end')
        self.text.mark_set('insert', '@%d,%d' % (event.x, event.y))
        if not self.rmenu:
            self.make_rmenu()
        
        rmenu = self.rmenu
        self.event = event
        iswin = sys.platform[:3] == 'win'
        if iswin:
            self.text.config(cursor = 'arrow')
        
        rmenu.tk_popup(event.x_root, event.y_root)
        if iswin:
            self.text.config(cursor = 'ibeam')
        

    rmenu_specs = [
        ('Close', '<<close-window>>')]
    
    def make_rmenu(self):
        rmenu = Menu(self.text, tearoff = 0)
        for label, eventname in self.rmenu_specs:
            
            def command(text = self.text, eventname = eventname):
                text.event_generate(eventname)

            rmenu.add_command(label = label, command = command)
        
        self.rmenu = rmenu

    
    def about_dialog(self, event = None):
        aboutDialog.AboutDialog(self.top, 'About IDLE')

    
    def config_dialog(self, event = None):
        configDialog.ConfigDialog(self.top, 'Settings')

    
    def help_dialog(self, event = None):
        fn = os.path.join(os.path.abspath(os.path.dirname(__file__)), 'help.txt')
        textView.TextViewer(self.top, 'Help', fn)

    
    def python_docs(self, event = None):
        if sys.platform[:3] == 'win':
            os.startfile(self.help_url)
        else:
            webbrowser.open(self.help_url)
        return 'break'

    
    def cut(self, event):
        self.text.event_generate('<<Cut>>')
        return 'break'

    
    def copy(self, event):
        if not self.text.tag_ranges('sel'):
            return None
        
        self.text.event_generate('<<Copy>>')
        return 'break'

    
    def paste(self, event):
        self.text.event_generate('<<Paste>>')
        return 'break'

    
    def select_all(self, event = None):
        self.text.tag_add('sel', '1.0', 'end-1c')
        self.text.mark_set('insert', '1.0')
        self.text.see('insert')
        return 'break'

    
    def remove_selection(self, event = None):
        self.text.tag_remove('sel', '1.0', 'end')
        self.text.see('insert')

    
    def move_at_edge_if_selection(self, edge_index):
        '''Cursor move begins at start or end of selection

        When a left/right cursor key is pressed create and return to Tkinter a
        function which causes a cursor move from the associated edge of the
        selection.

        '''
        self_text_index = self.text.index
        self_text_mark_set = self.text.mark_set
        edges_table = ('sel.first+1c', 'sel.last-1c')
        
        def move_at_edge(event):
            if event.state & 5 == 0:
                
                try:
                    self_text_index('sel.first')
                    self_text_mark_set('insert', edges_table[edge_index])
                except TclError:
                    pass
                except:
                    None<EXCEPTION MATCH>TclError
                

            None<EXCEPTION MATCH>TclError

        return move_at_edge

    
    def del_word_left(self, event):
        self.text.event_generate('<Meta-Delete>')
        return 'break'

    
    def del_word_right(self, event):
        self.text.event_generate('<Meta-d>')
        return 'break'

    
    def find_event(self, event):
        SearchDialog.find(self.text)
        return 'break'

    
    def find_again_event(self, event):
        SearchDialog.find_again(self.text)
        return 'break'

    
    def find_selection_event(self, event):
        SearchDialog.find_selection(self.text)
        return 'break'

    
    def find_in_files_event(self, event):
        GrepDialog.grep(self.text, self.io, self.flist)
        return 'break'

    
    def replace_event(self, event):
        ReplaceDialog.replace(self.text)
        return 'break'

    
    def goto_line_event(self, event):
        text = self.text
        lineno = tkSimpleDialog.askinteger('Goto', 'Go to line number:', parent = text)
        if lineno is None:
            return 'break'
        
        if lineno <= 0:
            text.bell()
            return 'break'
        
        text.mark_set('insert', '%d.0' % lineno)
        text.see('insert')

    
    def open_module(self, event = None):
        
        try:
            name = self.text.get('sel.first', 'sel.last')
        except TclError:
            name = ''

        name = name.strip()
        name = tkSimpleDialog.askstring('Module', 'Enter the name of a Python module\nto search on sys.path and open:', parent = self.text, initialvalue = name)
        if name:
            name = name.strip()
        
        if not name:
            return None
        
        
        try:
            (suffix, mode, type) = (f, file)
        except (NameError, ImportError):
            msg = None
            tkMessageBox.showerror('Import error', str(msg), parent = self.text)
            return None

        if type != imp.PY_SOURCE:
            tkMessageBox.showerror('Unsupported type', '%s is not a source module' % name, parent = self.text)
            return None
        
        if f:
            f.close()
        
        if self.flist:
            self.flist.open(file)
        else:
            self.io.loadfile(file)

    
    def open_class_browser(self, event = None):
        filename = self.io.filename
        if not filename:
            tkMessageBox.showerror('No filename', 'This buffer has no associated filename', master = self.text)
            self.text.focus_set()
            return None
        
        (head, tail) = os.path.split(filename)
        (base, ext) = os.path.splitext(tail)
        import ClassBrowser
        ClassBrowser.ClassBrowser(self.flist, base, [
            head])

    
    def open_path_browser(self, event = None):
        import PathBrowser
        PathBrowser.PathBrowser(self.flist)

    
    def gotoline(self, lineno):
        if lineno is not None and lineno > 0:
            self.text.mark_set('insert', '%d.0' % lineno)
            self.text.tag_remove('sel', '1.0', 'end')
            self.text.tag_add('sel', 'insert', 'insert +1l')
            self.center()
        

    
    def ispythonsource(self, filename):
        if not filename or os.path.isdir(filename):
            return True
        
        (base, ext) = os.path.splitext(os.path.basename(filename))
        if os.path.normcase(ext) in ('.py', '.pyw'):
            return True
        
        
        try:
            f = open(filename)
            line = f.readline()
            f.close()
        except IOError:
            return False

        if line.startswith('#!'):
            pass
        return line.find('python') >= 0

    
    def close_hook(self):
        if self.flist:
            self.flist.close_edit(self)
        

    
    def set_close_hook(self, close_hook):
        self.close_hook = close_hook

    
    def filename_change_hook(self):
        if self.flist:
            self.flist.filename_changed_edit(self)
        
        self.saved_change_hook()
        self.top.update_windowlist_registry(self)
        if self.ispythonsource(self.io.filename):
            self.addcolorizer()
        else:
            self.rmcolorizer()

    
    def addcolorizer(self):
        if self.color:
            return None
        
        self.per.removefilter(self.undo)
        self.color = self.ColorDelegator()
        self.per.insertfilter(self.color)
        self.per.insertfilter(self.undo)

    
    def rmcolorizer(self):
        if not self.color:
            return None
        
        self.color.removecolors()
        self.per.removefilter(self.undo)
        self.per.removefilter(self.color)
        self.color = None
        self.per.insertfilter(self.undo)

    
    def ResetColorizer(self):
        '''Update the colour theme if it is changed'''
        if self.color:
            self.color = self.ColorDelegator()
            self.per.insertfilter(self.color)
        
        theme = idleConf.GetOption('main', 'Theme', 'name')
        self.text.config(idleConf.GetHighlight(theme, 'normal'))

    
    def ResetFont(self):
        """Update the text widgets' font if it is changed"""
        fontWeight = 'normal'
        if idleConf.GetOption('main', 'EditorWindow', 'font-bold', type = 'bool'):
            fontWeight = 'bold'
        
        self.text.config(font = (idleConf.GetOption('main', 'EditorWindow', 'font'), idleConf.GetOption('main', 'EditorWindow', 'font-size'), fontWeight))

    
    def RemoveKeybindings(self):
        '''Remove the keybindings before they are changed.'''
        self.Bindings.default_keydefs = keydefs = idleConf.GetCurrentKeySet()
        for event, keylist in keydefs.items():
            self.text.event_delete(event, *keylist)
        
        for extensionName in self.get_standard_extension_names():
            xkeydefs = idleConf.GetExtensionBindings(extensionName)
            if xkeydefs:
                for event, keylist in xkeydefs.items():
                    self.text.event_delete(event, *keylist)
                
        

    
    def ApplyKeybindings(self):
        '''Update the keybindings after they are changed'''
        self.Bindings.default_keydefs = keydefs = idleConf.GetCurrentKeySet()
        self.apply_bindings()
        for extensionName in self.get_standard_extension_names():
            xkeydefs = idleConf.GetExtensionBindings(extensionName)
            if xkeydefs:
                self.apply_bindings(xkeydefs)
                continue
        
        menuEventDict = { }
        for menu in self.Bindings.menudefs:
            menuEventDict[menu[0]] = { }
            for item in menu[1]:
                if item:
                    menuEventDict[menu[0]][prepstr(item[0])[1]] = item[1]
                    continue
            
        
        for menubarItem in self.menudict.keys():
            menu = self.menudict[menubarItem]
            end = menu.index(END) + 1
            for index in range(0, end):
                if menu.type(index) == 'command':
                    accel = menu.entrycget(index, 'accelerator')
                    if accel:
                        itemName = menu.entrycget(index, 'label')
                        event = ''
                        if menuEventDict.has_key(menubarItem):
                            if menuEventDict[menubarItem].has_key(itemName):
                                event = menuEventDict[menubarItem][itemName]
                            
                        
                        if event:
                            accel = get_accelerator(keydefs, event)
                            menu.entryconfig(index, accelerator = accel)
                        
                    
                accel
            
        

    
    def set_notabs_indentwidth(self):
        '''Update the indentwidth if changed and not using tabs in this window'''
        if not self.usetabs:
            self.indentwidth = idleConf.GetOption('main', 'Indent', 'num-spaces', type = 'int')
        

    
    def reset_help_menu_entries(self):
        '''Update the additional help entries on the Help menu'''
        help_list = idleConf.GetAllExtraHelpSourcesList()
        helpmenu = self.menudict['help']
        helpmenu_length = helpmenu.index(END)
        if helpmenu_length > self.base_helpmenu_length:
            helpmenu.delete(self.base_helpmenu_length + 1, helpmenu_length)
        
        if help_list:
            helpmenu.add_separator()
            for entry in help_list:
                cmd = self._EditorWindow__extra_help_callback(entry[1])
                helpmenu.add_command(label = entry[0], command = cmd)
            
        
        self.menudict['help'] = helpmenu

    
    def __extra_help_callback(self, helpfile):
        '''Create a callback with the helpfile value frozen at definition time'''
        
        def display_extra_help(helpfile = helpfile):
            if not helpfile.startswith(('www', 'http')):
                url = os.path.normpath(helpfile)
            
            if sys.platform[:3] == 'win':
                os.startfile(helpfile)
            else:
                webbrowser.open(helpfile)

        return display_extra_help

    
    def update_recent_files_list(self, new_file = None):
        '''Load and update the recent files list and menus'''
        rf_list = []
        if os.path.exists(self.recent_files_path):
            rf_list_file = open(self.recent_files_path, 'r')
            
            try:
                rf_list = rf_list_file.readlines()
            finally:
                rf_list_file.close()

        
        if new_file:
            new_file = os.path.abspath(new_file) + '\n'
            if new_file in rf_list:
                rf_list.remove(new_file)
            
            rf_list.insert(0, new_file)
        
        bad_paths = []
        for path in rf_list:
            if '\x00' in path or not os.path.exists(path[0:-1]):
                bad_paths.append(path)
                continue
        
        rf_list = _[1]
        ulchars = '1234567890ABCDEFGHIJK'
        rf_list = rf_list[0:len(ulchars)]
        rf_file = open(self.recent_files_path, 'w')
        
        try:
            rf_file.writelines(rf_list)
        finally:
            rf_file.close()

        for instance in self.top.instance_dict.keys():
            menu = instance.recent_files_menu
            menu.delete(1, END)
            for i, file in zip(count(), rf_list):
                file_name = file[0:-1]
                ufile_name = self._filename_to_unicode(file_name)
                callback = instance._EditorWindow__recent_file_callback(file_name)
                menu.add_command(label = ulchars[i] + ' ' + ufile_name, command = callback, underline = 0)
            
        

    
    def __recent_file_callback(self, file_name):
        
        def open_recent_file(fn_closure = (file_name,)):
            self.io.open(editFile = fn_closure)

        return open_recent_file

    
    def saved_change_hook(self):
        short = self.short_title()
        long = self.long_title()
        if short and long:
            title = short + ' - ' + long
        elif short:
            title = short
        elif long:
            title = long
        else:
            title = 'Untitled'
        if not short and long:
            pass
        icon = title
        if not self.get_saved():
            title = '*%s*' % title
            icon = '*%s' % icon
        
        self.top.wm_title(title)
        self.top.wm_iconname(icon)

    
    def get_saved(self):
        return self.undo.get_saved()

    
    def set_saved(self, flag):
        self.undo.set_saved(flag)

    
    def reset_undo(self):
        self.undo.reset_undo()

    
    def short_title(self):
        filename = self.io.filename
        if filename:
            filename = os.path.basename(filename)
        
        return self._filename_to_unicode(filename)

    
    def long_title(self):
        if not self.io.filename:
            pass
        return self._filename_to_unicode('')

    
    def center_insert_event(self, event):
        self.center()

    
    def center(self, mark = 'insert'):
        text = self.text
        (top, bot) = self.getwindowlines()
        lineno = self.getlineno(mark)
        height = bot - top
        newtop = max(1, lineno - height // 2)
        text.yview(float(newtop))

    
    def getwindowlines(self):
        text = self.text
        top = self.getlineno('@0,0')
        bot = self.getlineno('@0,65535')
        if top == bot and text.winfo_height() == 1:
            height = int(text['height'])
            bot = top + height - 1
        
        return (top, bot)

    
    def getlineno(self, mark = 'insert'):
        text = self.text
        return int(float(text.index(mark)))

    
    def get_geometry(self):
        '''Return (width, height, x, y)'''
        geom = self.top.wm_geometry()
        m = re.match('(\\d+)x(\\d+)\\+(-?\\d+)\\+(-?\\d+)', geom)
        tuple = map(int, m.groups())
        return tuple

    
    def close_event(self, event):
        self.close()

    
    def maybesave(self):
        if self.io:
            if not self.get_saved():
                if self.top.state() != 'normal':
                    self.top.deiconify()
                
                self.top.lower()
                self.top.lift()
            
            return self.io.maybesave()
        

    
    def close(self):
        reply = self.maybesave()
        if str(reply) != 'cancel':
            self._close()
        
        return reply

    
    def _close(self):
        if self.io.filename:
            self.update_recent_files_list(new_file = self.io.filename)
        
        WindowList.unregister_callback(self.postwindowsmenu)
        if self.close_hook:
            self.close_hook()
        
        self.flist = None
        colorizing = 0
        self.unload_extensions()
        self.io.close()
        self.io = None
        self.undo = None
        if self.color:
            colorizing = self.color.colorizing
            if colorizing:
                pass
            doh = self.top
            self.color.close(doh)
        
        self.text = None
        self.tkinter_vars = None
        self.per.close()
        self.per = None
        if not colorizing:
            self.top.destroy()
        

    
    def load_extensions(self):
        self.extensions = { }
        self.load_standard_extensions()

    
    def unload_extensions(self):
        for ins in self.extensions.values():
            if hasattr(ins, 'close'):
                ins.close()
                continue
        
        self.extensions = { }

    
    def load_standard_extensions(self):
        for name in self.get_standard_extension_names():
            
            try:
                self.load_extension(name)
            continue
            print 'Failed to load extension', repr(name)
            import traceback
            traceback.print_exc()
            continue

        

    
    def get_standard_extension_names(self):
        return idleConf.GetExtensions(editor_only = True)

    
    def load_extension(self, name):
        
        try:
            mod = __import__(name, globals(), locals(), [])
        except ImportError:
            print '\nFailed to import extension: ', name
            return None

        cls = getattr(mod, name)
        keydefs = idleConf.GetExtensionBindings(name)
        if hasattr(cls, 'menudefs'):
            self.fill_menus(cls.menudefs, keydefs)
        
        ins = cls(self)
        self.extensions[name] = ins
        if keydefs:
            self.apply_bindings(keydefs)
            for vevent in keydefs.keys():
                methodname = vevent.replace('-', '_')
                while methodname[:1] == '<':
                    methodname = methodname[1:]
                while methodname[-1:] == '>':
                    methodname = methodname[:-1]
                methodname = methodname + '_event'
                if hasattr(ins, methodname):
                    self.text.bind(vevent, getattr(ins, methodname))
                    continue
            
        

    
    def apply_bindings(self, keydefs = None):
        if keydefs is None:
            keydefs = self.Bindings.default_keydefs
        
        text = self.text
        text.keydefs = keydefs
        for event, keylist in keydefs.items():
            if keylist:
                text.event_add(event, *keylist)
                continue
        

    
    def fill_menus(self, menudefs = None, keydefs = None):
        '''Add appropriate entries to the menus and submenus

        Menus that are absent or None in self.menudict are ignored.
        '''
        if menudefs is None:
            menudefs = self.Bindings.menudefs
        
        if keydefs is None:
            keydefs = self.Bindings.default_keydefs
        
        menudict = self.menudict
        text = self.text
        for mname, entrylist in menudefs:
            menu = menudict.get(mname)
            if not menu:
                continue
            
            for entry in entrylist:
                if not entry:
                    menu.add_separator()
                    continue
                (label, eventname) = entry
                checkbutton = label[:1] == '!'
                if checkbutton:
                    label = label[1:]
                
                (underline, label) = prepstr(label)
                accelerator = get_accelerator(keydefs, eventname)
                
                def command(text = text, eventname = eventname):
                    text.event_generate(eventname)

                if checkbutton:
                    var = self.get_var_obj(eventname, BooleanVar)
                    menu.add_checkbutton(label = label, underline = underline, command = command, accelerator = accelerator, variable = var)
                    continue
                menu.add_command(label = label, underline = underline, command = command, accelerator = accelerator)
            
        

    
    def getvar(self, name):
        var = self.get_var_obj(name)
        if var:
            value = var.get()
            return value
        else:
            raise NameError, name

    
    def setvar(self, name, value, vartype = None):
        var = self.get_var_obj(name, vartype)
        if var:
            var.set(value)
        else:
            raise NameError, name

    
    def get_var_obj(self, name, vartype = None):
        var = self.tkinter_vars.get(name)
        if not var and vartype:
            self.tkinter_vars[name] = var = vartype(self.text)
        
        return var

    
    def is_char_in_string(self, text_index):
        if self.color:
            if not self.text.tag_prevrange('TODO', text_index):
                pass
            return 'STRING' in self.text.tag_names(text_index)
        else:
            return 1

    
    def get_selection_indices(self):
        
        try:
            first = self.text.index('sel.first')
            last = self.text.index('sel.last')
            return (first, last)
        except TclError:
            return (None, None)


    
    def get_tabwidth(self):
        if not self.text['tabs']:
            pass
        current = TK_TABWIDTH_DEFAULT
        return int(current)

    
    def set_tabwidth(self, newtabwidth):
        text = self.text
        if self.get_tabwidth() != newtabwidth:
            pixels = text.tk.call('font', 'measure', text['font'], '-displayof', text.master, 'n' * newtabwidth)
            text.configure(tabs = pixels)
        

    
    def set_indentation_params(self, ispythonsource, guess = True):
        if guess and ispythonsource:
            i = self.guess_indent()
            if i <= i:
                pass
            elif i <= 8:
                self.indentwidth = i
            
            if self.indentwidth != self.tabwidth:
                self.usetabs = False
            
        
        self.set_tabwidth(self.tabwidth)

    
    def smart_backspace_event(self, event):
        text = self.text
        (first, last) = self.get_selection_indices()
        if first and last:
            text.delete(first, last)
            text.mark_set('insert', first)
            return 'break'
        
        chars = text.get('insert linestart', 'insert')
        if chars == '':
            if text.compare('insert', '>', '1.0'):
                text.delete('insert-1c')
            else:
                text.bell()
            return 'break'
        
        if chars[-1] not in ' \t':
            text.delete('insert-1c')
            return 'break'
        
        tabwidth = self.tabwidth
        have = len(chars.expandtabs(tabwidth))
        if not have > 0:
            raise AssertionError
        want = ((have - 1) // self.indentwidth) * self.indentwidth
        last_line_of_prompt = sys.ps1.split('\n')[-1]
        ncharsdeleted = 0
        while chars == last_line_of_prompt:
            break
        chars = chars[:-1]
        ncharsdeleted = ncharsdeleted + 1
        have = len(chars.expandtabs(tabwidth))
        if have <= want or chars[-1] not in ' \t':
            break
            continue
        continue
        text.undo_block_start()
        text.delete('insert-%dc' % ncharsdeleted, 'insert')
        if have < want:
            text.insert('insert', ' ' * (want - have))
        
        text.undo_block_stop()
        return 'break'

    
    def smart_indent_event(self, event):
        text = self.text
        (first, last) = self.get_selection_indices()
        text.undo_block_start()
        
        try:
            if first and last:
                if index2line(first) != index2line(last):
                    return self.indent_region_event(event)
                
                text.delete(first, last)
                text.mark_set('insert', first)
            
            prefix = text.get('insert linestart', 'insert')
            (raw, effective) = classifyws(prefix, self.tabwidth)
            if raw == len(prefix):
                self.reindent_to(effective + self.indentwidth)
            elif self.usetabs:
                pad = '\t'
            else:
                effective = len(prefix.expandtabs(self.tabwidth))
                n = self.indentwidth
                pad = ' ' * (n - effective % n)
            text.insert('insert', pad)
            text.see('insert')
            return 'break'
        finally:
            text.undo_block_stop()


    
    def newline_and_indent_event(self, event):
        text = self.text
        (first, last) = self.get_selection_indices()
        text.undo_block_start()
        
        try:
            if first and last:
                text.delete(first, last)
                text.mark_set('insert', first)
            
            line = text.get('insert linestart', 'insert')
            i = 0
            n = len(line)
            while i < n and line[i] in ' \t':
                i = i + 1
            if i == n:
                text.insert('insert linestart', '\n')
                return 'break'
            
            indent = line[:i]
            i = 0
            last_line_of_prompt = sys.ps1.split('\n')[-1]
            while line and line[-1] in ' \t' and line != last_line_of_prompt:
                line = line[:-1]
                i = i + 1
            if i:
                text.delete('insert - %d chars' % i, 'insert')
            
            while text.get('insert') in ' \t':
                text.delete('insert')
            text.insert('insert', '\n')
            lno = index2line(text.index('insert'))
            y = PyParse.Parser(self.indentwidth, self.tabwidth)
            if not self.context_use_ps1:
                for context in self.num_context_lines:
                    startat = max(lno - context, 1)
                    startatindex = `startat` + '.0'
                    rawtext = text.get(startatindex, 'insert')
                    y.set_str(rawtext)
                    bod = y.find_good_parse_start(self.context_use_ps1, self._build_char_in_string_func(startatindex))
                    if bod is not None or startat == 1:
                        break
                        continue
                
                if not bod:
                    pass
                y.set_lo(0)
            else:
                r = text.tag_prevrange('console', 'insert')
                if r:
                    startatindex = r[1]
                else:
                    startatindex = '1.0'
                rawtext = text.get(startatindex, 'insert')
                y.set_str(rawtext)
                y.set_lo(0)
            c = y.get_continuation_type()
            if c != PyParse.C_NONE:
                if c == PyParse.C_STRING_FIRST_LINE:
                    pass
                elif c == PyParse.C_STRING_NEXT_LINES:
                    text.insert('insert', indent)
                elif c == PyParse.C_BRACKET:
                    self.reindent_to(y.compute_bracket_indent())
                elif c == PyParse.C_BACKSLASH:
                    if y.get_num_lines_in_stmt() > 1:
                        text.insert('insert', indent)
                    else:
                        self.reindent_to(y.compute_backslash_indent())
                elif not 0:
                    raise AssertionError, 'bogus continuation type %r' % (c,)
                return 'break'
            
            indent = y.get_base_indent_string()
            text.insert('insert', indent)
            if y.is_block_opener():
                self.smart_indent_event(event)
            elif indent and y.is_block_closer():
                self.smart_backspace_event(event)
            
            return 'break'
        finally:
            text.see('insert')
            text.undo_block_stop()


    
    def _build_char_in_string_func(self, startindex):
        
        def inner(offset, _startindex = startindex, _icis = self.is_char_in_string):
            return _icis(_startindex + '+%dc' % offset)

        return inner

    
    def indent_region_event(self, event):
        (head, tail, chars, lines) = self.get_region()
        for pos in range(len(lines)):
            line = lines[pos]
            if line:
                (raw, effective) = classifyws(line, self.tabwidth)
                effective = effective + self.indentwidth
                lines[pos] = self._make_blanks(effective) + line[raw:]
                continue
        
        self.set_region(head, tail, chars, lines)
        return 'break'

    
    def dedent_region_event(self, event):
        (head, tail, chars, lines) = self.get_region()
        for pos in range(len(lines)):
            line = lines[pos]
            if line:
                (raw, effective) = classifyws(line, self.tabwidth)
                effective = max(effective - self.indentwidth, 0)
                lines[pos] = self._make_blanks(effective) + line[raw:]
                continue
        
        self.set_region(head, tail, chars, lines)
        return 'break'

    
    def comment_region_event(self, event):
        (head, tail, chars, lines) = self.get_region()
        for pos in range(len(lines) - 1):
            line = lines[pos]
            lines[pos] = '##' + line
        
        self.set_region(head, tail, chars, lines)

    
    def uncomment_region_event(self, event):
        (head, tail, chars, lines) = self.get_region()
        for pos in range(len(lines)):
            line = lines[pos]
            if not line:
                continue
            
            if line[:2] == '##':
                line = line[2:]
            elif line[:1] == '#':
                line = line[1:]
            
            lines[pos] = line
        
        self.set_region(head, tail, chars, lines)

    
    def tabify_region_event(self, event):
        (head, tail, chars, lines) = self.get_region()
        tabwidth = self._asktabwidth()
        for pos in range(len(lines)):
            line = lines[pos]
            if line:
                (raw, effective) = classifyws(line, tabwidth)
                (ntabs, nspaces) = divmod(effective, tabwidth)
                lines[pos] = '\t' * ntabs + ' ' * nspaces + line[raw:]
                continue
        
        self.set_region(head, tail, chars, lines)

    
    def untabify_region_event(self, event):
        (head, tail, chars, lines) = self.get_region()
        tabwidth = self._asktabwidth()
        for pos in range(len(lines)):
            lines[pos] = lines[pos].expandtabs(tabwidth)
        
        self.set_region(head, tail, chars, lines)

    
    def toggle_tabs_event(self, event):
        if self.askyesno('Toggle tabs', 'Turn tabs ' + ('on', 'off')[self.usetabs] + '?\nIndent width ' + ('will be', 'remains at')[self.usetabs] + ' 8.' + '\n Note: a tab is always 8 columns', parent = self.text):
            self.usetabs = not (self.usetabs)
            self.indentwidth = 8
        
        return 'break'

    
    def change_indentwidth_event(self, event):
        new = self.askinteger('Indent width', 'New indent width (2-16)\n(Always use 8 when using tabs)', parent = self.text, initialvalue = self.indentwidth, minvalue = 2, maxvalue = 16)
        if new and new != self.indentwidth and not (self.usetabs):
            self.indentwidth = new
        
        return 'break'

    
    def get_region(self):
        text = self.text
        (first, last) = self.get_selection_indices()
        if first and last:
            head = text.index(first + ' linestart')
            tail = text.index(last + '-1c lineend +1c')
        else:
            head = text.index('insert linestart')
            tail = text.index('insert lineend +1c')
        chars = text.get(head, tail)
        lines = chars.split('\n')
        return (head, tail, chars, lines)

    
    def set_region(self, head, tail, chars, lines):
        text = self.text
        newchars = '\n'.join(lines)
        if newchars == chars:
            text.bell()
            return None
        
        text.tag_remove('sel', '1.0', 'end')
        text.mark_set('insert', head)
        text.undo_block_start()
        text.delete(head, tail)
        text.insert(head, newchars)
        text.undo_block_stop()
        text.tag_add('sel', head, 'insert')

    
    def _make_blanks(self, n):
        if self.usetabs:
            (ntabs, nspaces) = divmod(n, self.tabwidth)
            return '\t' * ntabs + ' ' * nspaces
        else:
            return ' ' * n

    
    def reindent_to(self, column):
        text = self.text
        text.undo_block_start()
        if text.compare('insert linestart', '!=', 'insert'):
            text.delete('insert linestart', 'insert')
        
        if column:
            text.insert('insert', self._make_blanks(column))
        
        text.undo_block_stop()

    
    def _asktabwidth(self):
        if not self.askinteger('Tab width', 'Columns per tab? (2-16)', parent = self.text, initialvalue = self.indentwidth, minvalue = 2, maxvalue = 16):
            pass
        return self.tabwidth

    
    def guess_indent(self):
        (opener, indented) = IndentSearcher(self.text, self.tabwidth).run()
        if opener and indented:
            (raw, indentsmall) = classifyws(opener, self.tabwidth)
            (raw, indentlarge) = classifyws(indented, self.tabwidth)
        else:
            indentsmall = indentlarge = 0
        return indentlarge - indentsmall



def index2line(index):
    return int(float(index))


def classifyws(s, tabwidth):
    raw = effective = 0
    for ch in s:
        if ch == ' ':
            raw = raw + 1
            effective = effective + 1
            continue
        if ch == '\t':
            raw = raw + 1
            effective = (effective // tabwidth + 1) * tabwidth
            continue
    
    return (raw, effective)

import tokenize
_tokenize = tokenize
del tokenize

class IndentSearcher(object):
    
    def __init__(self, text, tabwidth):
        self.text = text
        self.tabwidth = tabwidth
        self.i = self.finished = 0
        self.blkopenline = None
        self.indentedline = None

    
    def readline(self):
        if self.finished:
            return ''
        
        i = self.i = self.i + 1
        mark = repr(i) + '.0'
        if self.text.compare(mark, '>=', 'end'):
            return ''
        
        return self.text.get(mark, mark + ' lineend+1c')

    
    def tokeneater(self, type, token, start, end, line, INDENT = _tokenize.INDENT, NAME = _tokenize.NAME, OPENERS = ('class', 'def', 'for', 'if', 'try', 'while')):
        if self.finished:
            pass
        elif type == NAME and token in OPENERS:
            self.blkopenline = line
        elif type == INDENT and self.blkopenline:
            self.indentedline = line
            self.finished = 1
        

    
    def run(self):
        save_tabsize = _tokenize.tabsize
        _tokenize.tabsize = self.tabwidth
        
        try:
            _tokenize.tokenize(self.readline, self.tokeneater)
        except _tokenize.TokenError:
            pass
        finally:
            _tokenize.tabsize = save_tabsize

        return (self.blkopenline, self.indentedline)



def prepstr(s):
    i = s.find('_')
    if i >= 0:
        s = s[:i] + s[i + 1:]
    
    return (i, s)

keynames = {
    'bracketleft': '[',
    'bracketright': ']',
    'slash': '/' }

def get_accelerator(keydefs, eventname):
    keylist = keydefs.get(eventname)
    if not keylist:
        return ''
    
    s = keylist[0]
    s = re.sub('-[a-z]\\b', (lambda m: m.group().upper()), s)
    s = re.sub('\\b\\w+\\b', (lambda m: keynames.get(m.group(), m.group())), s)
    s = re.sub('Key-', '', s)
    s = re.sub('Cancel', 'Ctrl-Break', s)
    s = re.sub('Control-', 'Ctrl-', s)
    s = re.sub('-', '+', s)
    s = re.sub('><', ' ', s)
    s = re.sub('<', '', s)
    s = re.sub('>', '', s)
    return s


def fixwordbreaks(root):
    tk = root.tk
    tk.call('tcl_wordBreakAfter', 'a b', 0)
    tk.call('set', 'tcl_wordchars', '[a-zA-Z0-9_]')
    tk.call('set', 'tcl_nonwordchars', '[^a-zA-Z0-9_]')


def test():
    root = Tk()
    fixwordbreaks(root)
    root.withdraw()
    if sys.argv[1:]:
        filename = sys.argv[1]
    else:
        filename = None
    edit = EditorWindow(root = root, filename = filename)
    edit.set_close_hook(root.quit)
    root.mainloop()
    root.destroy()

if __name__ == '__main__':
    test()

