# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

'''
A number of function that enhance IDLE on MacOSX when it used as a normal
GUI application (as opposed to an X11 application).
'''
import sys
import Tkinter

def runningAsOSXApp():
    ''' Returns True iff running from the IDLE.app bundle on OSX '''
    if sys.platform == 'darwin':
        pass
    return 'IDLE.app' in sys.argv[0]


def addOpenEventSupport(root, flist):
    '''
    This ensures that the application will respont to open AppleEvents, which
    makes is feaseable to use IDLE as the default application for python files.
    '''
    
    def doOpenFile(*args):
        for fn in args:
            flist.open(fn)
        

    root.createcommand('::tk::mac::OpenDocument', doOpenFile)


def hideTkConsole(root):
    
    try:
        root.tk.call('console', 'hide')
    except Tkinter.TclError:
        pass



def overrideRootMenu(root, flist):
    """
    Replace the Tk root menu by something that's more appropriate for
    IDLE.
    """
    Menu = Menu
    Text = Text
    Text = Text
    import Tkinter
    prepstr = prepstr
    get_accelerator = get_accelerator
    import EditorWindow
    import Bindings
    import WindowList
    MultiCallCreator = MultiCallCreator
    import MultiCall
    menubar = Menu(root)
    root.configure(menu = menubar)
    menudict = { }
    menudict['windows'] = menu = Menu(menubar, name = 'windows')
    menubar.add_cascade(label = 'Window', menu = menu, underline = 0)
    
    def postwindowsmenu(menu = (menu,)):
        end = menu.index('end')
        if end is None:
            end = -1
        
        if end > 0:
            menu.delete(0, end)
        
        WindowList.add_windows_to_menu(menu)

    WindowList.register_callback(postwindowsmenu)
    menudict['application'] = menu = Menu(menubar, name = 'apple')
    menubar.add_cascade(label = 'IDLE', menu = menu)
    
    def about_dialog(event = (None,)):
        import aboutDialog
        aboutDialog.AboutDialog(root, 'About IDLE')

    
    def config_dialog(event = (None,)):
        import configDialog
        configDialog.ConfigDialog(root, 'Settings')

    root.bind('<<about-idle>>', about_dialog)
    root.bind('<<open-config-dialog>>', config_dialog)
    if flist:
        root.bind('<<close-all-windows>>', flist.close_all_callback)
    
    tkversion = root.tk.eval('info patchlevel')
    if tkversion >= '8.4.14':
        Bindings.menudefs[0] = ('application', [
            ('About IDLE', '<<about-idle>>'),
            None])
        root.createcommand('::tk::mac::ShowPreferences', config_dialog)
    else:
        for mname, entrylist in Bindings.menudefs:
            menu = menudict.get(mname)
            if not menu:
                continue
                continue
            for entry in entrylist:
                if not entry:
                    menu.add_separator()
                    continue
                (label, eventname) = entry
                (underline, label) = prepstr(label)
                accelerator = get_accelerator(Bindings.default_keydefs, eventname)
                
                def command(text = root, eventname = eventname):
                    text.event_generate(eventname)

                menu.add_command(label = label, underline = underline, command = command, accelerator = accelerator)
            
        


def setupApp(root, flist):
    '''
    Perform setup for the OSX application bundle.
    '''
    if not runningAsOSXApp():
        return None
    
    hideTkConsole(root)
    overrideRootMenu(root, flist)
    addOpenEventSupport(root, flist)

