# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

import os
import subprocess
import string
import re
import pty
import warnings
warnings.filterwarnings('ignore', 'apt API not stable yet', FutureWarning)
import apt_pkg
from PyKDE4.kdecore import *
from PyKDE4.kdeui import *
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4 import uic
from DebPackage import DebPackage, Cache
import gettext
from GDebiCommon import GDebiCommon
from KDEAptDialogs import *

def _(str):
    return unicode(gettext.gettext(str), 'UTF-8')


def __(catalog, str):
    return unicode(gettext.dgettext(catalog, str), 'UTF-8')


def utf8(str):
    if isinstance(str, unicode):
        return str
    
    return unicode(str, 'UTF-8')


def loadUi(file, parent):
    '''load local file if possible else use installed file'''
    if os.path.exists('data/' + file):
        uic.loadUi('data/' + file, parent)
    else:
        uic.loadUi('/usr/share/gdebi/' + file, parent)


class DumbTerminal(QTextEdit):
    ''' a very dumb terminal '''
    
    def __init__(self, parent_frame):
        ''' really dumb terminal with simple editing support '''
        QTextEdit.__init__(self, parent_frame)
        self.setFontFamily('Monospace')
        self.setFontPointSize(8)
        self.setWordWrapMode(QTextOption.NoWrap)
        self.setUndoRedoEnabled(False)
        self._block = False
        self.connect(self, SIGNAL('cursorPositionChanged(int,int)'), self.onCursorPositionChanged)

    
    def setInstallProgress(self, installProgress):
        self.installProgress = installProgress

    
    def insertWithTermCodes(self, text):
        ''' support basic terminal codes '''
        display_text = ''
        for c in text:
            if c == chr(8):
                self.moveCursor(QTextEdit.MoveBackward, QTextCursor.KeepAnchor)
                self.cut()
                continue
            if c == chr(13):
                continue
            if c == chr(7):
                continue
            display_text += c
        
        self.insertPlainText(display_text)

    
    def keyPressEvent(self, ev):
        ''' send (ascii) key events to the pty '''
        if not hasattr(self.installProgress, 'master_fd'):
            return None
        
        if ev.key() == Qt.Key_Backspace:
            os.write(self.installProgress.master_fd, chr(8))
            return None
        
        if not ev.text():
            return None
        
        os.write(self.installProgress.master_fd, ev.text().toUtf8())

    
    def onCursorPositionChanged(self, x, y):
        ''' helper that ensures that the cursor is always at the end '''
        if self._block:
            return None
        
        self._block = True
        para = self.paragraphs() - 1
        pos = self.paragraphLength(para)
        self.moveCursor(QTextCursor.End)
        self._block = False



class GDebiKDEDialog(QDialog):
    '''Our main user interface, load from UI file'''
    
    def __init__(self, parent):
        QDialog.__init__(self, parent)
        loadUi('GDebiKDEDialog.ui', self)



class GDebiKDE(GDebiCommon, GDebiKDEDialog):
    
    def __init__(self, datadir, options, file = '', parent = None, name = None, modal = 0, fl = 0):
        GDebiKDEDialog.__init__(self, parent)
        GDebiCommon.__init__(self, datadir, options, file)
        self.setWindowIcon(KIcon('adept_installer'))
        self.textLabel1.setText(_('Package:'))
        self.textLabel1_2.setText(_('Status:'))
        self.detailsButton.setText(_('Details'))
        self.tabWidget2.setTabText(0, _('Description'))
        self.tabWidget2.setTabText(1, _('Details'))
        self.tabWidget2.setTabText(2, _('Included Files'))
        self.cancelButton.setText(__('kdelibs', '&Cancel'))
        self.installButton.setText(_('&Install Package'))
        self.DetailsVersionLabel.setText(_('<b>Version:</b>'))
        self.DetailsMaintainerLabel.setText(_('<b>Maintainer:</b>'))
        self.DetailsPriorityLabel.setText(_('<b>Priority:</b>'))
        self.DetailsSectionLabel.setText(_('<b>Section:</b>'))
        self.DetailsSizeLabel.setText(_('<b>Size:</b>'))
        self.setDisabled(True)
        self.PackageProgressBar.setEnabled(True)
        self.detailsButton.hide()
        self.installButton.setIcon(KIcon('dialog-ok'))
        self.cancelButton.setIcon(KIcon('dialog-cancel'))
        self.show()
        self.kapp = KApplication.kApplication()
        self.kapp.processEvents()
        self.cprogress = CacheProgressAdapter(self.PackageProgressBar)
        if not self.openCache():
            KMessageBox.error(self, '<b>' + self.error_header + '</b><br>' + self.error_body, self.error_header)
            sys.exit(1)
        
        if file != '' and os.path.exists(file):
            self.open(file)
        else:
            header = _('The package file does not exist')
            body = _('A nonexistent file has been selected for installation. Please select an existing .deb package file.')
            KMessageBox.error(self, '<b>' + header + '</b><br>' + body, header)
            sys.exit(1)
        self.setEnabled(True)
        self.PackageProgressBar.hide()
        self.connect(self.cancelButton, SIGNAL('clicked()'), self.cancelButtonClicked)
        self.connect(self.installButton, SIGNAL('clicked()'), self.installButtonClicked)
        self.connect(self.detailsButton, SIGNAL('clicked()'), self.detailsButtonClicked)

    
    def open(self, file):
        ''' load the .deb file '''
        res = GDebiCommon.open(self, file)
        if res == False:
            KMessageBox.error(self, '<b>' + self.error_header + '</b><br>' + self.error_body, self.error_header)
            return False
        
        self.setWindowTitle(_('Package Installer - %s') % self._deb.pkgName)
        self.textLabel1_3.setText(self._deb.pkgName)
        buf = self.DecriptionEdit
        
        try:
            long_desc = ''
            raw_desc = string.split(utf8(self._deb['Description']), '\n')
            summary = raw_desc[0]
            raw_desc[0] = ''
            long_desc = '%s\n' % summary
            for line in raw_desc:
                tmp = string.strip(line)
                if tmp == '.':
                    long_desc += '\n'
                    continue
                long_desc += tmp + '\n'
            
            p = re.compile('^(\\s|\\t)*(\\*|0|-)', re.MULTILINE)
            long_desc = p.sub('\n*', long_desc)
            long_desc = re.sub('\\n', '</b>\n', long_desc, 1)
            p = re.compile('\\n', re.MULTILINE)
            long_desc = p.sub(' ', long_desc)
            p = re.compile('\\s\\s+', re.MULTILINE)
            long_desc = p.sub('</p><p>', long_desc)
            long_desc = '<p><b>' + long_desc + '</p>'
            buf.setText(long_desc)
        except KeyError:
            buf.setText(_('No description is available'))

        if not self._deb.checkDeb():
            self.installButton.setEnabled(False)
            self.textLabel1_3_2.setText('<font color="#ff0000"> Error: ' + self._deb._failureString + '</font>')
            self.detailsButton.hide()
            return False
        
        self.compareDebWithCache()
        if self._deb.compareToVersionInCache() == DebPackage.VERSION_SAME:
            self.installButton.setText(_('&Reinstall Package'))
            self.installButton.setIcon(KIcon('view-refresh'))
        
        self.getChanges()
        if self.version_info_title != '' and self.version_info_msg != '':
            self.infoIcon.setPixmap(DesktopIcon('dialog-information'))
            self.infoBox.setText(self.version_info_title + '\n' + self.version_info_msg)
        
        if len(self.install) == len(self.install):
            pass
        elif len(self.install) == 0:
            pass
        else:
            self.detailsButton.show()
        self.textLabel1_3_2.setText(self.deps)
        self.DetailsVersion.setText(self._deb['Version'])
        self.DetailsMaintainer.setText(utf8(self._deb['Maintainer']))
        self.DetailsPriority.setText(self._deb['Priority'])
        self.DetailsSection.setText(utf8(self._deb['Section']))
        self.DetailsSize.setText(self._deb['Installed-Size'] + ' KB')
        buf = self.IncFilesEdit
        buf.setText('\n'.join(self._deb.filelist))
        if not self._deb.checkDeb():
            self.installButton.setText(_('&Install Package'))
        
        if self._deb.compareToVersionInCache() == DebPackage.VERSION_SAME:
            self.installButton.setText(_('Re&install Package'))
        

    
    def cancelButtonClicked(self):
        self.close()

    
    def detailsButtonClicked(self):
        changedList = QStringList()
        (install, remove, unauthenticated) = self._deb.requiredChanges
        for i in install:
            changedList.append(_('To be installed: %s') % i)
        
        for r in remove:
            changedList.append(_('To be removed: %s') % r)
        
        infoReport = KMessageBox.informationList(self, _('<b>To install the following changes are required:</b>'), changedList, _('Details'))

    
    def installButtonClicked(self):
        if os.getuid() != 0:
            if os.path.exists('gdebi-kde'):
                executable = os.path.curdir + '/gdebi-kde'
            else:
                executable = '/usr/bin/gdebi-kde'
            print 'executable ' + executable
            os.execl('/usr/bin/kdesudo', 'kdesudo', executable + ' -n ', self._deb.file)
            self.kapp.exit()
        
        if not self.try_acquire_lock():
            KMessageBox.error(self, '<b>' + self.error_header + '</b><br>' + self.error_body, self.error_header)
            return False
        
        if not self.try_acquire_lock():
            KMessageBox.error(self, '<b>' + self.error_header + '</b><br>' + self.error_body, self.error_header)
            return False
        
        self.setDisabled(True)
        self.installDialog = GDebiKDEInstall(self)
        self.installDialog.show()
        if len(self.install) > 0 or len(self.remove) > 0:
            if not self.acquire_lock():
                KMessageBox.sorry(self, '<b>' + self.error_header + '</b><br>' + self.error_body, self.error_header)
                return False
            
            fprogress = KDEFetchProgressAdapter(self.installDialog.installationProgress, self.installDialog.installingLabel, self.installDialog)
            iprogress = KDEInstallProgressAdapter(self.installDialog.installationProgress, self.installDialog.installingLabel, self.installDialog)
            self.installDialog.konsole.setInstallProgress(iprogress)
            errMsg = None
            
            try:
                res = self._cache.commit(fprogress, iprogress)
            except IOError:
                msg = None
                res = False
                errMsg = '%s' % msg
                header = _('Could not download all required files')
                body = _('Please check your internet connection or installation medium.')
            except SystemError:
                msg = None
                res = False
                header = _('Could not install all dependencies')
                body = _('Usually this is related to an error of the software distributor. See the terminal window for more details.')

            if not res:
                self.errorReport = KMessageBox.error(self, header + '<br>' + body, header)
                return None
            
        
        dprogress = KDEDpkgInstallProgress(self._deb.file, self.installDialog.installingLabel, self.installDialog.installationProgress, self.installDialog.konsole, self.installDialog)
        dprogress.commit()
        self.installDialog.setWindowTitle(_('Installation finished'))
        if dprogress.exitstatus == 0:
            self.installDialog.installingLabel.setText(_('<b>' + "Package '%s' was installed" + '</b>') % self._deb.pkgName)
        else:
            self.installDialog.installingLabel.setText('<b>' + _("Failed to install package '%s'") % os.path.basename(self._deb.file) + '</b>')
            self.installDialog.konsoleFrame.show()
        self._cache = Cache()
        if self._cache._depcache.BrokenCount > 0:
            header = _('Failed to completely install all dependencies')
            text = _("To fix this run 'sudo apt-get install -f' in a terminal window.")
            self.errorReport = KMessageBox.error(self, header + text, header)
            sys.exit(1)
        



class GDebiKDEInstall(QDialog):
    
    def __init__(self, parent):
        QDialog.__init__(self, parent)
        loadUi('GDebiKDEInstallDialog.ui', self)
        self.showDetailsButton.setText(__('libept', 'Show Details'))
        self.closeButton.setText(__('kdelibs', '&Close'))
        self.showDetailsButton.setIcon(KIcon('utilities-terminal'))
        self.closeButton.setIcon(KIcon('window-close'))
        self.closeButton.setEnabled(False)
        self.closeButton.setVisible(False)
        self.parent = parent
        self.konsole = None
        self.konsoleFrameLayout = QHBoxLayout(self.konsoleFrame)
        self.konsoleFrame.hide()
        self.newKonsole()
        kapp = KApplication.kApplication()
        kapp.processEvents()

    
    def newKonsole(self):
        self.konsole = DumbTerminal(self.konsoleFrame)
        self.konsoleFrame.setMinimumSize(500, 400)
        self.konsoleFrameLayout.addWidget(self.konsole)

    
    def showTerminal(self):
        if self.konsoleFrame.isVisible():
            self.konsoleFrame.hide()
            self.showDetailsButton.setText(__('libept', 'Show Details'))
            QTimer.singleShot(1, self.changeSize)
        else:
            self.konsoleFrame.show()
            self.showDetailsButton.setText(__('libept', 'Hide Details'))

    
    def changeSize(self):
        self.resize(self.minimumSize())

    
    def closeButtonClicked(self):
        self.close()

    
    def closeEvent(self, event):
        self.close()

    
    def close(self):
        self.accept()
        KApplication.kApplication().exit()


