# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

import sys
import os
import subprocess
import string
import apt
import apt_pkg
from PyKDE4.kdecore import *
from PyKDE4.kdeui import *
from PyQt4.QtCore import *
from PyQt4.QtGui import *
import urllib
import fcntl
import posix
import time
import thread
import re
import pty
import select
from DebPackage import DebPackage, Cache
from apt.progress import InstallProgress
from gettext import gettext as gett

def _(str):
    return unicode(gett(str), 'UTF-8')


def utf8(str):
    if isinstance(str, unicode):
        return str
    
    return unicode(str, 'UTF-8')


class KDEDpkgInstallProgress(object):
    '''The frontend for dpkg -i'''
    
    def __init__(self, debfile, status, progress, konsole, parent):
        self.debfile = debfile
        self.status = status
        self.progress = progress
        self.konsole = konsole
        self.parent = parent
        self.konsole.setInstallProgress(self)
        self.progress.setValue(0)

    
    def timeoutHandler(self, signum, frame):
        raise IOError, 'Stopped waiting for I/O.'

    
    def commit(self):
        self.status.setText(_("Installing '%s'...") % os.path.basename(self.debfile))
        cmd = '/usr/bin/dpkg'
        argv = [
            cmd,
            '-i',
            self.debfile]
        (self.child_pid, self.master_fd) = pty.fork()
        if self.child_pid == 0:
            os.environ['TERM'] = 'dumb'
            if not os.environ.has_key('DEBIAN_FRONTEND'):
                os.environ['DEBIAN_FRONTEND'] = 'noninteractive'
            
            os.environ['APT_LISTCHANGES_FRONTEND'] = 'none'
            exitstatus = subprocess.call(argv)
            os._exit(exitstatus)
        
        while True:
            
            try:
                (rlist, wlist, xlist) = select.select([
                    self.master_fd], [], [], 0.001)
                if len(rlist) > 0:
                    line = os.read(self.master_fd, 255)
                    self.parent.konsole.insertWithTermCodes(utf8(line))
            except Exception:
                e = None
                if e.errno == 11:
                    continue
                
                break

            KApplication.kApplication().processEvents()
        (pid, status) = os.waitpid(self.child_pid, 0)
        self.exitstatus = os.WEXITSTATUS(status)
        self.progress.setValue(100)
        self.parent.closeButton.setEnabled(True)
        self.parent.closeButton.setVisible(True)
        self.parent.installationProgress.setVisible(False)
        QTimer.singleShot(1, self.parent.changeSize)



class KDEInstallProgressAdapter(InstallProgress):
    
    def __init__(self, progress, action, parent):
        InstallProgress.__init__(self)
        self.progress = progress
        self.action = action
        self.parent = parent
        self.finished = False
        self.parent.konsole.setInstallProgress(self)

    
    def child_exited(self, process):
        self.finished = True
        self.apt_status = process.exitStatus()
        self.finished = True

    
    def error(self, pkg, errormsg):
        pass

    
    def conffile(self, current, new):
        pass

    
    def startUpdate(self):
        apt_pkg.PkgSystemUnLock()
        self.action.setText(_('Installing dependencies...'))
        self.progress.setValue(0)

    
    def statusChange(self, pkg, percent, status):
        self.progress.setValue(percent)

    
    def updateInterface(self):
        
        try:
            InstallProgress.updateInterface(self)
        except ValueError:
            e = None

        while True:
            
            try:
                (rlist, wlist, xlist) = select.select([
                    self.master_fd], [], [], 0.01)
                if len(rlist) > 0:
                    line = os.read(self.master_fd, 255)
                    self.parent.konsole.insertWithTermCodes(utf8(line))
            continue
            except Exception:
                e = None
                break
                continue
            

            None<EXCEPTION MATCH>Exception
        KApplication.kApplication().processEvents()

    
    def fork(self):
        '''pty voodoo'''
        (self.child_pid, self.master_fd) = pty.fork()
        if self.child_pid == 0:
            os.environ['TERM'] = 'dumb'
            if not os.environ.has_key('DEBIAN_FRONTEND'):
                os.environ['DEBIAN_FRONTEND'] = 'noninteractive'
            
            os.environ['APT_LISTCHANGES_FRONTEND'] = 'none'
        
        return self.child_pid

    
    def waitChild(self):
        while True:
            
            try:
                select.select([
                    self.statusfd], [], [], self.selectTimeout)
            except Exception:
                e = None

            self.updateInterface()
            (pid, res) = os.waitpid(self.child_pid, os.WNOHANG)
            if pid == self.child_pid:
                break
                continue
        return os.WEXITSTATUS(res)



class KDEFetchProgressAdapter(apt.progress.FetchProgress):
    
    def __init__(self, progress, label, parent):
        self.progress = progress
        self.label = label
        self.parent = parent

    
    def start(self):
        self.label.setText(_('Downloading additional package files...'))
        self.progress.setValue(0)

    
    def stop(self):
        pass

    
    def pulse(self):
        apt.progress.FetchProgress.pulse(self)
        self.progress.setValue(self.percent)
        currentItem = self.currentItems + 1
        if currentItem > self.totalItems:
            currentItem = self.totalItems
        
        if self.currentCPS > 0:
            self.label.setText(_('Downloading additional package files...') + _('File %s of %s at %sB/s' % (self.currentItems, self.totalItems, apt_pkg.SizeToStr(self.currentCPS))))
        else:
            self.label.setText(_('Downloading additional package files...') + _('File %s of %s' % (self.currentItems, self.totalItems)))
        KApplication.kApplication().processEvents()
        return True

    
    def mediaChange(self, medium, drive):
        msg = _("Please insert '%s' into the drive '%s'") % (medium, drive)
        change = KMessageBox.questionYesNo(None, _('Media Change'), _('Media Change') + '<br>' + msg, KStandardGuiItem.ok(), KStandardGuiItem.cancel())
        if change == KMessageBox.Yes:
            return True
        
        return False



class CacheProgressAdapter(apt.progress.FetchProgress):
    
    def __init__(self, progressbar):
        self.progressbar = progressbar

    
    def update(self, percent):
        self.progressbar.show()
        self.progressbar.setValue(percent)
        KApplication.kApplication().processEvents()

    
    def done(self):
        pass


