# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

import Image
import ImageFile
_handler = None

def register_handler(handler):
    global _handler
    _handler = handler


def _accept(prefix):
    return prefix[:6] == 'SIMPLE'


class FITSStubImageFile(ImageFile.StubImageFile):
    format = 'FITS'
    format_description = 'FITS'
    
    def _open(self):
        offset = self.fp.tell()
        if not _accept(self.fp.read(6)):
            raise SyntaxError('Not a FITS file')
        
        self.fp.seek(offset)
        self.mode = 'F'
        self.size = (1, 1)
        loader = self._load()
        if loader:
            loader.open(self)
        

    
    def _load(self):
        return _handler



def _save(im, fp, filename):
    if _handler is None or not hasattr('_handler', 'save'):
        raise IOError('FITS save handler not installed')
    
    _handler.save(im, fp, filename)

Image.register_open(FITSStubImageFile.format, FITSStubImageFile, _accept)
Image.register_save(FITSStubImageFile.format, _save)
Image.register_extension(FITSStubImageFile.format, '.fit')
Image.register_extension(FITSStubImageFile.format, '.fits')
