# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

import Image
import ImageFile
_handler = None

def register_handler(handler):
    global _handler
    _handler = handler


def _accept(prefix):
    if prefix[0:4] == 'GRIB':
        pass
    return prefix[7] == chr(1)


class GribStubImageFile(ImageFile.StubImageFile):
    format = 'GRIB'
    format_description = 'GRIB'
    
    def _open(self):
        offset = self.fp.tell()
        if not _accept(self.fp.read(8)):
            raise SyntaxError('Not a GRIB file')
        
        self.fp.seek(offset)
        self.mode = 'F'
        self.size = (1, 1)
        loader = self._load()
        if loader:
            loader.open(self)
        

    
    def _load(self):
        return _handler



def _save(im, fp, filename):
    if _handler is None or not hasattr('_handler', 'save'):
        raise IOError('GRIB save handler not installed')
    
    _handler.save(im, fp, filename)

Image.register_open(GribStubImageFile.format, GribStubImageFile, _accept)
Image.register_save(GribStubImageFile.format, _save)
Image.register_extension(GribStubImageFile.format, '.grib')
