# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

import urllib
import urlparse
from datetime import datetime
from operator import eq as OP_EQ, gt as OP_GT, lt as OP_LT
from lpconstants import BUGLIST
from bugbase import Bug as LPBug
from exceptions import PythonLaunchpadBugsValueError

def minbug(bug, minbug):
    if int(bug) >= minbug:
        pass
    return bug


def filterbug(bug, buglist):
    if int(bug) not in buglist:
        pass
    return bug


def hasbranch(bug, cls = None):
    
    try:
        br = bug.branches
        if not br:
            return False
        elif True:
            pass
        return bug
    except AttributeError:
        if cls:
            
            try:
                bug = cls(bug)
                br = bug.branches
                if not br:
                    return False
                elif True:
                    pass
                return bug
            raise RuntimeError, 'Something went wrong'

        
    except:
        cls



def reporter(bug, reporter, cls = None):
    
    try:
        if bug.reporter == reporter:
            pass
        return bug
    except AttributeError:
        if cls:
            
            try:
                bug = cls(bug)
                if x.reporter == reporter:
                    pass
                return bug
            raise RuntimeError, 'Something went wrong'

        else:
            raise NotImplementedError, 'Please define your own reporter-filterfunction'
    except:
        cls



def get_current_task(bug, listurl, cls = None):
    
    try:
        t = bug.infotable
    except AttributeError:
        if cls:
            
            try:
                bug = cls(bug)
                t = bug.infotable
            raise RuntimeError, 'Something went wrong'

        else:
            raise NotImplementedError, 'Please define your own get_current_task-filterfunction'
    except:
        cls

    if t._current is None:
        idx_fallback = None
        y = t.current_from_listurl(listurl)
        for idx, a in enumerate(t):
            if a.is_current(y):
                t._current = idx
                break
            
            if a.target == y[2]:
                idx_fallback = idx
                continue
        elif not idx_fallback is not None:
            raise AssertionError, "parsing of '%s' went wrong" % bug.url
        t._current = idx_fallback
    
    return bug


def lastcomment(bug, cls = None, **comment_def):
    '''
    comment_def["user"], type: str or lphelper.user or "reporter"
    comment_def["before"], type: datetime
    comment_def["after"], type: datetime
    comment_def["operation"], in ["|","&"]
    '''
    if not comment_def:
        raise TypeError, 'lastcomment-function needs at least one definitional argument'
    
    if not set(comment_def.keys()) <= set([
        'user',
        'before',
        'after',
        'operation',
        'at']):
        raise TypeError, 'unknown definitional argument for lastcomment'
    
    if 'at' in comment_def.keys():
        if 'before' in comment_def.keys() or 'after' in comment_def.keys():
            raise TypeError, "'at' and 'after' or 'before' is not allowed"
        
    
    conditions = []
    operation = comment_def.get('operation', '|')
    if operation not in ('|', '&'):
        raise ValueError, 'unknown operation'
    
    
    try:
        c = bug.comments
        if not c:
            return False
        
        lastcomment = c[-1]
    except AttributeError:
        if cls:
            
            try:
                bug = cls(bug)
                c = bug.comments
                if not c:
                    return False
                
                lastcomment = c[-1]
            raise RuntimeError, 'Something went wrong'

        else:
            raise NotImplementedError, 'Please define your own reporter-filterfunction'
    except:
        cls

    if 'user' in comment_def:
        if comment_def['user'] == 'reporter':
            comment_def['user'] = bug.reporter
        
        conditions.append(lastcomment.user == comment_def['user'])
    
    if 'at' in comment_def:
        conditions.append(lastcomment.date.timetuple()[:3] == comment_def['at'].timetuple()[:3])
    
    if 'before' in comment_def:
        conditions.append(lastcomment.date <= comment_def['before'])
    
    if 'after' in comment_def:
        conditions.append(lastcomment.date >= comment_def['after'])
    
    if operation == '&':
        if False not in conditions:
            pass
        return bug
    elif True in conditions:
        pass
    return bug


class date_filter(object):
    DATEREPORTED = 'date'
    DATEUPDATED = 'date_updated'
    
    def __init__(self, date_def, date_kind, cls = None):
        '''
        date_def = ("=" or ">" or "<" , date (type of datetime))
        '''
        abort = False
        
        try:
            if not issubclass(cls, LPBug):
                abort = True
        except TypeError:
            if not issubclass(cls.cls, LPBug):
                abort = True
            
        except:
            issubclass(cls.cls, LPBug)

        if abort:
            raise TypeError
        
        self.cls = cls
        (op, value) = date_def
        self.op = {
            '=': OP_EQ,
            '<': OP_LT,
            '>': OP_GT }[op]
        self.value = value.date()
        today = datetime.today().date()
        if self.value > today:
            raise PythonLaunchpadBugsValueError({
                'date_filter(%s)' % date_kind: 'The given date (%s) is in the future' % self.value })
        elif self.value == today and op == '>':
            raise PythonLaunchpadBugsValueError({
                'date_filter(%s)' % date_kind: "You can not search for bugs reported in the future (op='%s', date='%s')" % (op, self.value) })
        
        self.date_state = False
        self.kind = date_kind

    
    def __call__(self, bug):
        if not isinstance(bug, LPBug):
            bug = self.cls(bug)
        
        
        try:
            date = getattr(bug, self.kind)
        except AttributeError:
            raise ValueError, "Unable to filter the list of bugs by '%s'" % self.kind

        date = date.date()
        result = self.op(date, self.value)
        if result:
            self.date_state = True
        elif self.date_state:
            if self.kind == date_filter.DATEREPORTED:
                x = (map,)((lambda i: self.op(i.date_created.date(), self.value)), bug.infotable)
                if True in x:
                    self.date_state = True
                    return bug
                
            
            self.date_state = False
            raise StopFiltering
        
        if result:
            pass
        return bug



class datereported(date_filter):
    ''' class to ensure backward compatibility '''
    
    def __init__(self, date_def, cls = None):
        date_filter.__init__(self, date_def, date_filter.DATEREPORTED, cls)



class dateupdated(date_filter):
    ''' class to ensure backward compatibility '''
    
    def __init__(self, date_def, cls = None):
        date_filter.__init__(self, date_def, date_filter.DATEUPDATED, cls)



class StopFiltering(StopIteration):
    pass


class LPBugListFilter(object):
    
    def __init__(self, func = None):
        if not func:
            pass
        self._functions = []
        self._func_cache = self._functions[:]

    
    def functions(self):
        return self._functions

    functions = property(functions)
    
    def reset(self):
        self._functions = self._func_cache



def parse_options(url_opt):
    result = { }
    if url_opt:
        for i in urllib.unquote_plus(url_opt).split('&'):
            k = i.split('=')
            
            try:
                result[k[0]].add(k[1])
            continue
            result[k[0]] = set([
                k[1]])
            continue

        
    
    return result


class URLBugListFilter(LPBugListFilter):
    ADD = 1
    OVERWRITE = 2
    CONFLICTS_ERROR = 3
    OPTION_DICT = {
        'status': 'field.status:list',
        'importance': 'field.importance:list',
        'tag': 'field.tag',
        'assignee': 'field.assignee',
        'reporter': 'field.bug_reporter',
        'contact': 'field.bug_supervisor',
        'supervisor': 'field.bug_supervisor',
        'commenter': 'field.bug_commenter',
        'subscriber': 'field.subscriber',
        'duplicates': 'field.omit_dupes',
        'component': 'field.component',
        'cve': 'field.has_cve',
        'has-patch': 'field.has_patch',
        'upstream-status': 'field.status_upstream',
        'milestone': 'field.milestone:list',
        'orderby': 'orderby',
        'batch': 'batch' }
    
    def __init__(self, url_opt = '', func = [], opt_type = CONFLICTS_ERROR):
        self._conflicts_error = opt_type
        self._URLBugListFilter__url_opt = parse_options(url_opt)
        self._URLBugListFilter__baseurl = ()
        self._URLBugListFilter__url_cache = self._URLBugListFilter__url_opt.copy()
        LPBugListFilter.__init__(self, func)

    
    def __call__(self, baseurl):
        self.baseurl = baseurl
        return self

    
    def reset(self):
        self._functions = self._func_cache
        self._URLBugListFilter__url_opt = self._URLBugListFilter__url_cache

    
    def get_baseurl(self):
        if not self._URLBugListFilter__baseurl:
            raise AssertionError, 'needs baseurl'
        x = list(self._URLBugListFilter__baseurl[:3])
        x.append(self.urlopt)
        x.append('')
        return urlparse.urlunsplit(x)

    
    def set_baseurl(self, baseurl):
        self._URLBugListFilter__baseurl = urlparse.urlsplit(baseurl)
        self._add_default_urlopt(baseurl)

    baseurl = property(get_baseurl, set_baseurl)
    
    def urlopt(self):
        return urllib.urlencode(self._URLBugListFilter__url_opt, True)

    urlopt = property(urlopt)
    
    def add_option(self, option, value):
        if option not in URLBugListFilter.OPTION_DICT:
            raise ValueError
        
        self._add_option({
            URLBugListFilter.OPTION_DICT[option]: value })

    
    def _add_default_urlopt(self, url):
        u = urlparse.urlsplit(url)
        r = parse_options(u[3])
        self._add_option(r)

    
    def _add_option(self, r):
        if self._conflicts_error == URLBugListFilter.ADD:
            for i, k in r.iteritems():
                
                try:
                    self._URLBugListFilter__url_opt[i] = self._URLBugListFilter__url_opt[i].union(k)
                continue
                except KeyError:
                    self._URLBugListFilter__url_opt[i] = k
                    continue
                

            
        elif self._conflicts_error == URLBugListFilter.OVERWRITE:
            self._URLBugListFilter__url_opt = r
        elif self._conflicts_error == URLBugListFilter.CONFLICTS_ERROR:
            for i, k in r.iteritems():
                if isinstance(k, set) and len(k) == 1:
                    k = k.pop()
                
                if i in self._URLBugListFilter__url_opt:
                    if not self._URLBugListFilter__url_opt[i] == k:
                        
                        try:
                            if k in self._URLBugListFilter__url_opt[i]:
                                pass
                        raise ValueError, 'ValueError: conflict filter options (%s)' % i

                    
                self._URLBugListFilter__url_opt[i] == k
                self._URLBugListFilter__url_opt[i] = k
            
        else:
            raise ValueError, 'unknown type=%s' % type


if __name__ == '__main__':
    import connector as Connector
    tBug = Connector.ConnectBug(method = 'text')
    tBuglist = Connector.ConnectBugList(method = 'text')
    from datetime import datetime
    f = LPBugListFilter([
        (lambda x: minbug(x, 175000))])
    bugs = [
        172802,
        137574,
        177608,
        146377,
        175946,
        162814,
        173005,
        177202,
        116243,
        138837,
        174103,
        172882,
        172637,
        172670]
    print f.filter(bugs)
    f = URLBugListFilter(func = ((lambda x: lastcomment(x, tBug, user = 'reporter')),))
    bugs = tBuglist(f('https://bugs.edge.launchpad.net/python-launchpad-bugs/+bugs?field.searchtext=&orderby=-importance&search=Search&field.status%3Alist=NEW&field.status%3Alist=INCOMPLETE_WITH_RESPONSE&field.status%3Alist=CONFIRMED&field.status%3Alist=TRIAGED&field.status%3Alist=INPROGRESS&field.status%3Alist=FIXCOMMITTED&field.assignee=&field.bug_reporter=&field.omit_dupes=on&field.has_patch=&field.has_no_package='))
    print bugs, len(bugs)

