# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

import re
from lpconstants import BUG, BLUEPRINT
re_escape = re.compile(u'�|\\x0f|\\x10|\\x02|\\x07')

def unicode_for_libxml2(text):
    ''' helper function to fix encoding errors in libxml2 '''
    u = unicode(text, 'UTF-8')
    ret = re_escape.sub('??', u)
    return ret.encode('UTF-8')


def _attr_ext(i, s):
    if i.startswith('__'):
        return '_%s%s' % (s.__class__.__name__, i)
    else:
        return i


def _gen_getter(attr):
    ''' Returns a function to return the value of an attribute
    
    Example:
        get_example = _gen_getter("x.y")
    is like:
        def get_example(self):
            if not x.parsed:
                x.parse()
            return x.y
    
    '''
    
    def func(s):
        attributes = attr.split('.')
        attributes = (map,)((lambda a: _attr_ext(a, s)), attributes)
        x = getattr(s, attributes[0])
        attributes.insert(0, s)
        if not x.parsed:
            x.parse()
        
        return reduce(getattr, attributes)

    return func


def _gen_setter(attr):
    ''' Returns a function to set the value of an attribute
    
    Example:
        set_example = _gen_setter("x.y")
    is like:
        def set_example(self, value):
            if not x.parsed:
                x.parse()
            x.y = value
    
    '''
    
    def func(s, value):
        attributes = attr.split('.')
        attributes = (map,)((lambda a: _attr_ext(a, s)), attributes)
        x = getattr(s, attributes[0])
        attributes.insert(0, s)
        if not x.parsed:
            x.parse()
        
        setattr(reduce(getattr, attributes[:-1]), attributes[-1], value)

    return func


def sort(x, y, sort):
    if sort == 'nr':
        return cmp(int(x.bugnumber), int(y.bugnumber))
    elif sort == 'importance':
        return cmp(BUG.SORT_IMPORTANCE.index(x.importance), BUG.SORT_IMPORTANCE.index(y.importance))
    elif sort == 'status':
        return cmp(BUG.SORT_STATUS.index(x.status), BUG.SORT_STATUS.index(y.status))
    


def blueprint_sort(x, y, sort):
    if sort == 'priority':
        return cmp(BLUEPRINT.SORT_PRIORITY.index(getattr(x, sort)), BLUEPRINT.SORT_PRIORITY.index(getattr(y, sort)))
    elif sort == 'status':
        return cmp(BLUEPRINT.SORT_STATUS.index(getattr(x, sort)), BLUEPRINT.SORT_STATUS.index(getattr(y, sort)))
    elif sort == 'delivery':
        return cmp(BLUEPRINT.SORT_DELIVERY.index(getattr(x, sort)), BLUEPRINT.SORT_DELIVERY.index(getattr(y, sort)))
    else:
        return cmp(getattr(x, sort), getattr(y, sort))


class user(str):
    user_regex = re.compile('^(.+)\\s\\((\\S+)\\)$', re.UNICODE)
    
    def parse_text_user(usr):
        x = user.user_regex.search(unicode(usr, 'UTF-8'))
        if x:
            return user(x.group(2), x.group(1))
        
        return usr

    parse_text_user = staticmethod(parse_text_user)
    
    def parse_html_user(node):
        ''' takes a lp standard user node and returns a user object.
        
        Example for such a node:
        * <a href="/~ogra">Oliver Grawert</a>
        * <a href="https://blueprints.edge.launchpad.net/~ogra">
                <img alt="" width="14" height="14" src="/@@/person" />&nbsp;Oliver Grawert
          </a>
        '''
        realname = unicode(node.content.strip('\n '), 'UTF-8')
        realname = realname.lstrip(u' ')
        return user(unicode(node.prop('href').split('~').pop().split('/')[0], 'UTF-8'), realname)

    parse_html_user = staticmethod(parse_html_user)
    
    def __new__(cls, lplogin, realname = None, attributes = None):
        obj = super(user, cls).__new__(user, lplogin)
        obj._user__lplogin = lplogin
        obj._user__realname = realname
        if attributes is None:
            attributes = set()
        
        obj._user__attributes = attributes
        return obj

    
    def realname(self):
        if not self._user__realname:
            pass
        return 'unknown'

    realname = property(realname)
    
    def lplogin(self):
        return self._user__lplogin

    lplogin = property(lplogin)
    
    def _attributes(self):
        return self._user__attributes

    _attributes = property(_attributes)
    
    def __repr__(self):
        f = '<user %s (%s)>' % (self._user__lplogin, self.realname)
        return f.encode('ascii', 'replace')

    
    def __str__(self):
        if not self._user__lplogin:
            pass
        return ''

    
    def __nonzero__(self):
        if self._user__lplogin:
            return True
        else:
            return False



class product(str):
    product_regex = re.compile('^(\\S+)(\\s\\(([\\w ]+)\\))?$', re.UNICODE)
    
    def parse_text_product(prod_str):
        x = product.product_regex.search(prod_str)
        if x:
            target = None
            a = x.group(3)
            if a:
                a = a.split()
                if len(a) > 1:
                    target = a[-1]
                
                longname = '%s (%s)' % (x.group(1), a[0])
            else:
                longname = x.group(1)
            return (product(x.group(1), longname), target)
        
        x = prod_str.split()
        if len(x) == 2:
            if x[0].istitle():
                return (product(x[0].lower(), x[0]), x[1])
            
        
        return (prod_str, None)

    parse_text_product = staticmethod(parse_text_product)
    
    def __new__(cls, lpname, longname = None, type = None, tracked_in = None):
        obj = super(product, cls).__new__(product, lpname)
        obj._product__lpname = lpname
        obj._product__longname = longname
        obj._product__type = type
        obj._product__tracked_in = tracked_in
        return obj

    
    def longname(self):
        if not self._product__longname and self._product__lpname:
            pass
        return 'unknown'

    longname = property(longname)
    
    def type(self):
        return self._product__type

    type = property(type)
    
    def tracked_in(self):
        return self._product__tracked_in

    tracked_in = property(tracked_in)
    
    def __str__(self):
        if not self._product__lpname:
            pass
        return ''

    
    def __repr__(self):
        return '<product %s (%s, type=%s, tracked in=%s)>' % (self._product__lpname, self.longname, self._product__type, self._product__tracked_in)

    
    def __nonzero__(self):
        if self._product__lpname:
            return True
        else:
            return False



class change_obj(object):
    ''' shows the status of a changed object  '''
    
    def __init__(self, attr, action = 'changed'):
        '''
        * attr: edited attribute
        * action: describes the way the attribute was edited
        '''
        self._change_obj__attr = attr
        self._change_obj__action = action

    
    def component(self):
        return self._change_obj__attr

    component = property(component)
    
    def action(self):
        return self._change_obj__action

    action = property(action)
    
    def __str__(self):
        return s

    
    def __repr__(self):
        return '<Changes to %s>' % self._change_obj__attr



class LateBindingProperty(property):
    ''' Allow late bindig properties.
    
    Thanks to Maric Michaud,
    http://mail.python.org/pipermail/python-list/2006-September/401908.html'''
    __doc__ = property.__dict__['__doc__']
    
    def __init__(self, fget = None, fset = None, fdel = None, doc = None):
        if fget:
            
            fget = lambda s, n = fget.__name__: getattr(s, n)()
        
        if fset:
            
            fset = lambda s, v, n = fset.__name__: getattr(s, n)(v)
        
        if fdel:
            
            fdel = lambda s, n = fdel.__name__: getattr(s, n)()
        
        property.__init__(self, fget, fset, fdel, doc)


