# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

__version__ = '0.9'

def getCodes():
    '''Returns a dict mapping code names to widgets'''
    BarcodeI2of5 = BarcodeI2of5
    BarcodeCode128 = BarcodeCode128
    BarcodeStandard93 = BarcodeStandard93
    BarcodeExtended93 = BarcodeExtended93
    BarcodeStandard39 = BarcodeStandard39
    BarcodeExtended39 = BarcodeExtended39
    BarcodeMSI = BarcodeMSI
    BarcodeCodabar = BarcodeCodabar
    BarcodeCode11 = BarcodeCode11
    BarcodeFIM = BarcodeFIM
    BarcodePOSTNET = BarcodePOSTNET
    BarcodeUSPS_4State = BarcodeUSPS_4State
    import widgets
    Ean13BarcodeWidget = Ean13BarcodeWidget
    Ean8BarcodeWidget = Ean8BarcodeWidget
    import eanbc
    codes = { }
    for widget in (BarcodeI2of5, BarcodeCode128, BarcodeStandard93, BarcodeExtended93, BarcodeStandard39, BarcodeExtended39, BarcodeMSI, BarcodeCodabar, BarcodeCode11, BarcodeFIM, BarcodePOSTNET, BarcodeUSPS_4State, Ean13BarcodeWidget, Ean8BarcodeWidget):
        codeName = widget.codeName
        codes[codeName] = widget
    
    return codes


def getCodeNames():
    '''Returns sorted list of supported bar code names'''
    return sorted(getCodes().keys())


def createBarcodeDrawing(codeName, **options):
    '''This creates and returns a drawing with a barcode.
    '''
    Drawing = Drawing
    Group = Group
    import reportlab.graphics.shapes
    codes = getCodes()
    bcc = codes[codeName]
    width = options.pop('width', None)
    height = options.pop('height', None)
    isoScale = options.pop('isoScale', 0)
    kw = { }
    for k, v in options.iteritems():
        if k.startswith('_') or k in bcc._attrMap:
            kw[k] = v
            continue
    
    bc = bcc(**kw)
    (x1, y1, x2, y2) = bc.getBounds()
    w = float(x2 - x1)
    h = float(y2 - y1)
    sx = width not in ('auto', None)
    sy = height not in ('auto', None)
    if sx or sy:
        if not sx or width / w:
            pass
        sx = 1
        if not sy or height / h:
            pass
        sy = 1
        if isoScale:
            if sx < 1 and sy < 1:
                sx = sy = max(sx, sy)
            else:
                sx = sy = min(sx, sy)
        
        w *= sx
        h *= sy
    else:
        sx = sy = 1
    d = Drawing(width = w, height = h, transform = [
        sx,
        0,
        0,
        sy,
        -sx * x1,
        -sy * y1])
    d.add(bc, '_bc')
    return d


def createBarcodeImageInMemory(codeName, **options):
    '''This creates and returns barcode as an image in memory.
    '''
    d = createBarcodeDrawing(codeName, **options)
    return d.asString(format)

