# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

__version__ = ' $Id: attrmap.py 2741 2005-12-07 21:52:33Z andy $ '
from UserDict import UserDict
from reportlab.lib.validators import isAnything, _SequenceTypes, DerivedValue
from reportlab import rl_config

class CallableValue:
    '''a class to allow callable initial values'''
    
    def __init__(self, func, *args, **kw):
        self.func = func
        self.args = args
        self.kw = kw

    
    def __call__(self):
        return apply(self.func, self.args, self.kw)



class AttrMapValue:
    '''Simple multi-value holder for attribute maps'''
    
    def __init__(self, validate = None, desc = None, initial = None, **kw):
        if not validate:
            pass
        self.validate = isAnything
        self.desc = desc
        self._initial = initial
        for k, v in kw.items():
            setattr(self, k, v)
        

    
    def __getattr__(self, name):
        if name == 'initial':
            if isinstance(self._initial, CallableValue):
                return self._initial()
            
            return self._initial
        elif name == 'hidden':
            return 0
        
        raise AttributeError, name



class AttrMap(UserDict):
    
    def __init__(self, BASE = None, UNWANTED = [], **kw):
        data = { }
        if BASE:
            if isinstance(BASE, AttrMap):
                data = BASE.data
            elif type(BASE) not in (type(()), type([])):
                BASE = (BASE,)
            
            for B in BASE:
                if hasattr(B, '_attrMap'):
                    data.update(getattr(B._attrMap, 'data', { }))
                    continue
                raise ValueError, 'BASE=%s has wrong kind of value' % str(B)
            
        
        UserDict.__init__(self, data)
        self.remove(UNWANTED)
        self.data.update(kw)

    
    def update(self, kw):
        if isinstance(kw, AttrMap):
            kw = kw.data
        
        self.data.update(kw)

    
    def remove(self, unwanted):
        for k in unwanted:
            
            try:
                del self[k]
            continue
            except KeyError:
                continue
            

        

    
    def clone(self, UNWANTED = [], **kw):
        c = AttrMap(BASE = self, UNWANTED = UNWANTED)
        c.update(kw)
        return c



def validateSetattr(obj, name, value):
    '''validate setattr(obj,name,value)'''
    if rl_config.shapeChecking:
        map = obj._attrMap
        if map and name[0] != '_':
            pass
        None if isinstance(value, DerivedValue) else None<EXCEPTION MATCH>KeyError
    
    obj.__dict__[name] = value


def _privateAttrMap(obj, ret = 0):
    '''clone obj._attrMap if required'''
    A = obj._attrMap
    oA = getattr(obj.__class__, '_attrMap', None)
    if ret:
        if oA is A:
            return (A.clone(), oA)
        else:
            return (A, None)
    elif oA is A:
        obj._attrMap = A.clone()
    


def _findObjectAndAttr(src, P):
    '''Locate the object src.P for P a string, return parent and name of attribute
    '''
    P = string.split(P, '.')
    if len(P) == 0:
        return (None, None)
    else:
        for p in P[0:-1]:
            src = getattr(src, p)
        
        return (src, P[-1])


def hook__setattr__(obj):
    if not hasattr(obj, '__attrproxy__'):
        C = obj.__class__
        import new
        obj.__class__ = new.classobj(C.__name__, (C,) + C.__bases__, {
            '__attrproxy__': [],
            '__setattr__': (lambda self, k, v, osa = getattr(obj, '__setattr__', None), hook = hook: hook(self, k, v, osa)) })
    


def addProxyAttribute(src, name, validate = None, desc = None, initial = None, dst = None):
    """
    Add a proxy attribute 'name' to src with targets dst
    """
    if not hasattr(src, '_attrMap'):
        raise AssertionError, 'src object has no _attrMap'
    (A, oA) = _privateAttrMap(src, 1)
    if type(dst) not in _SequenceTypes:
        dst = (dst,)
    
    D = []
    DV = []
    for d in dst:
        if type(d) in _SequenceTypes:
            d = d[0]
            e = d[1:]
        
        (obj, attr) = _findObjectAndAttr(src, d)
        if obj:
            dA = getattr(obj, '_attrMap', None)
            continue
    

