# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

""" This module includes some reusable routines for ReportLab's
 'Corporate Image' - the logo, standard page backdrops and
 so on - you are advised to do the same for your own company!"""
__version__ = ' $Id: corp.py 2484 2004-12-10 07:27:50Z andy $ '
from reportlab.lib.units import inch, cm
from reportlab.lib.validators import *
from reportlab.lib.attrmap import *
from reportlab.graphics.shapes import definePath, Group, Drawing, Rect, PolyLine, String
from reportlab.graphics.widgetbase import Widget
from reportlab.lib.colors import Color, black, white, ReportLabBlue
from reportlab.pdfbase.pdfmetrics import stringWidth
from math import sin, pi

class RL_CorpLogo(Widget):
    """Dinu's fat letter logo as hacked into decent paths by Robin"""
    _attrMap = AttrMap(x = AttrMapValue(isNumber, 'Logo x-coord'), y = AttrMapValue(isNumber, 'Logo y-coord'), angle = AttrMapValue(isNumber, 'Logo rotation'), strokeColor = AttrMapValue(isColorOrNone, 'Logo lettering stroke color'), fillColor = AttrMapValue(isColorOrNone, 'Logo lettering fill color'), strokeWidth = AttrMapValue(isNumber, 'Logo lettering stroke width'), background = AttrMapValue(isColorOrNone, desc = 'Logo background color'), border = AttrMapValue(isColorOrNone, desc = 'Logo border color'), borderWidth = AttrMapValue(isNumber, desc = 'Logo border width (1)'), shadow = AttrMapValue(isNumberOrNone, desc = 'None or fraction of background for shadowing'), width = AttrMapValue(isNumber, desc = 'width in points of the logo (default 129)'), height = AttrMapValue(isNumber, desc = 'height in points of the logo (default 86)'), skewX = AttrMapValue(isNumber, desc = 'x-skew of the logo (default 10)'), skewY = AttrMapValue(isNumber, desc = 'y-skew of the logo (default 0)'), showPage = AttrMapValue(isBoolean, desc = 'If true show the page lines'), xFlip = AttrMapValue(isBoolean, desc = 'If true do x reversal'), yFlip = AttrMapValue(isBoolean, desc = 'If true do y reversal'))
    
    def __init__(self):
        self.fillColor = white
        self.strokeColor = None
        self.strokeWidth = 0.1
        self.background = ReportLabBlue
        self.border = None
        self.borderWidth = 1
        self.shadow = 0.5
        self.height = 86
        self.width = 130
        self.x = self.y = self.angle = self.skewY = self._dx = 0
        self.skewX = 10
        self._dy = 35.5
        self.showPage = 1

    
    def demo(self):
        D = Drawing(self.width, self.height)
        D.add(self)
        return D

    
    def _paintLogo(self, g, dx = 0, dy = 0, strokeColor = None, strokeWidth = 0.1, fillColor = white):
        if not self.showPage and [
            ('moveTo', 38.3063, -7.28346),
            ('lineTo', 38.3063, -25.5526),
            ('lineTo', 85.1578, -25.5526),
            ('lineTo', 85.1578, -1.39019),
            ('lineTo', 90.4617, -1.39019),
            ('lineTo', 90.4617, -31.1512),
            ('lineTo', 32.7077, -31.1512),
            ('lineTo', 32.7077, -7.28346),
            'closePath',
            ('moveTo', 32.7077, 14.5216),
            ('lineTo', 32.7077, 47.8186),
            ('lineTo', 80.1485, 47.8186),
            ('lineTo', 90.4617, 37.2107),
            ('lineTo', 90.4617, 20.1202),
            ('lineTo', 85.1578, 20.1202),
            ('lineTo', 85.1578, 30.7281),
            ('lineTo', 73.6659, 30.7281),
            ('lineTo', 73.6659, 42.22),
            ('lineTo', 38.3063, 42.22),
            ('lineTo', 38.3063, 14.5216),
            'closePath',
            ('moveTo', 79.2645, 36.3267),
            ('lineTo', 85.1578, 36.3267),
            ('lineTo', 79.2645, 42.22),
            'closePath']:
            pass
        P = [
            ('moveTo', 15.7246, 0),
            ('lineTo', 9.49521, 0),
            ('lineTo', 6.64988, 6.83711),
            ('curveTo', 6.62224, 6.95315, 6.57391, 7.10646, 6.50485, 7.29708),
            ('curveTo', 6.43578, 7.48767, 6.35059, 7.71559, 6.24931, 7.98079),
            ('lineTo', 6.29074, 6.71282),
            ('lineTo', 6.29074, 0),
            ('lineTo', 0.55862, 0),
            ('lineTo', 0.55862, 19.1937),
            ('lineTo', 6.45649, 19.1937),
            ('curveTo', 9.05324, 19.1937, 10.9962, 18.7337, 12.2853, 17.8138),
            ('curveTo', 13.9244, 16.637, 14.7439, 14.9629, 14.7439, 12.7916),
            ('curveTo', 14.7439, 10.4711, 13.6435, 8.86755, 11.4428, 7.98079),
            'closePath',
            ('moveTo', 6.31838, 10.3054),
            ('lineTo', 6.70513, 10.3054),
            ('curveTo', 7.36812, 10.3054, 7.92062, 10.5333, 8.36261, 10.9891),
            ('curveTo', 8.80461, 11.4449, 9.0256, 12.025, 9.0256, 12.7295),
            ('curveTo', 9.0256, 14.1632, 8.19227, 14.88, 6.52556, 14.88),
            ('lineTo', 6.31838, 14.88),
            'closePath',
            ('moveTo', 25.0617, 4.54978),
            ('lineTo', 30.4761, 4.45033),
            ('curveTo', 30.0895, 2.88402, 29.3367, 1.70513, 28.2179, 0.91369),
            ('curveTo', 27.0991, 0.12223, 25.6373, -0.27348, 23.8325, -0.27348),
            ('curveTo', 21.6961, -0.27348, 20.0202, 0.32322, 18.8047, 1.5166),
            ('curveTo', 17.5985, 2.72658, 16.9953, 4.37988, 16.9953, 6.47662),
            ('curveTo', 16.9953, 8.6065, 17.6445, 10.3427, 18.9429, 11.6853),
            ('curveTo', 20.2412, 13.0361, 21.9171, 13.7115, 23.9706, 13.7115),
            ('curveTo', 26.0148, 13.7115, 27.6447, 13.061, 28.8602, 11.7599),
            ('curveTo', 30.0757, 10.4504, 30.6833, 8.71423, 30.6833, 6.5512),
            ('lineTo', 30.6559, 5.66859),
            ('lineTo', 22.5341, 5.66859),
            ('curveTo', 22.5985, 4.29287, 23.0313, 3.60503, 23.8325, 3.60503),
            ('curveTo', 24.4586, 3.60503, 24.8684, 3.91994, 25.0617, 4.54978),
            'closePath',
            ('moveTo', 25.186, 8.35371),
            ('curveTo', 25.186, 8.60235, 25.1538, 8.83024, 25.0894, 9.03742),
            ('curveTo', 25.0249, 9.24463, 24.9351, 9.42278, 24.82, 9.57197),
            ('curveTo', 24.7049, 9.72113, 24.5691, 9.83923, 24.4125, 9.92624),
            ('curveTo', 24.256, 10.0133, 24.0857, 10.0568, 23.9015, 10.0568),
            ('curveTo', 23.5147, 10.0568, 23.2017, 9.89725, 22.9623, 9.57819),
            ('curveTo', 22.7228, 9.25913, 22.6031, 8.85096, 22.6031, 8.35371),
            'closePath',
            ('moveTo', 38.3631, -5.99181),
            ('lineTo', 32.8243, -5.99181),
            ('lineTo', 32.8243, 13.438),
            ('lineTo', 38.3631, 13.438),
            ('lineTo', 38.2387, 11.5361),
            ('curveTo', 38.4689, 11.9339, 38.7037, 12.2716, 38.9433, 12.5492),
            ('curveTo', 39.1825, 12.8269, 39.4404, 13.0527, 39.7168, 13.2267),
            ('curveTo', 39.9929, 13.4007, 40.2899, 13.5271, 40.6075, 13.6059),
            ('curveTo', 40.9252, 13.6846, 41.2776, 13.724, 41.6642, 13.724),
            ('curveTo', 43.1007, 13.724, 44.2702, 13.0776, 45.1725, 11.7847),
            ('curveTo', 46.0659, 10.5084, 46.5123, 8.81368, 46.5123, 6.70038),
            ('curveTo', 46.5123, 4.55394, 46.0842, 2.85502, 45.2278, 1.60362),
            ('curveTo', 44.3898, 0.35221, 43.2342, -0.27348, 41.7608, -0.27348),
            ('curveTo', 40.4166, -0.27348, 39.2424, 0.42679, 38.2387, 1.82739),
            ('curveTo', 38.2847, 1.40472, 38.3124, 1.04007, 38.3215, 0.73345),
            ('curveTo', 38.3492, 0.41851, 38.3631, 0.04146, 38.3631, -0.3978),
            'closePath',
            ('moveTo', 40.7802, 6.84954),
            ('curveTo', 40.7802, 7.72802, 40.6673, 8.40964, 40.4419, 8.89448),
            ('curveTo', 40.2162, 9.37929, 39.8962, 9.62168, 39.4819, 9.62168),
            ('curveTo', 38.6253, 9.62168, 38.1972, 8.68108, 38.1972, 6.79983),
            ('curveTo', 38.1972, 4.87712, 38.6118, 3.91581, 39.4404, 3.91581),
            ('curveTo', 39.8547, 3.91581, 40.1817, 4.1727, 40.421, 4.68654),
            ('curveTo', 40.6606, 5.20037, 40.7802, 5.92135, 40.7802, 6.84954),
            'closePath',
            ('moveTo', 62.1065, 6.51392),
            ('curveTo', 62.1065, 4.44205, 61.4712, 2.79288, 60.2003, 1.56631),
            ('curveTo', 58.9297, 0.33978, 57.2263, -0.27348, 55.0896, -0.27348),
            ('curveTo', 52.9902, -0.27348, 51.3191, 0.35221, 50.0759, 1.60362),
            ('curveTo', 48.8419, 2.8633, 48.2252, 4.55394, 48.2252, 6.67551),
            ('curveTo', 48.2252, 8.79709, 48.8558, 10.5002, 50.1175, 11.7847),
            ('curveTo', 51.3698, 13.0776, 53.0317, 13.724, 55.1035, 13.724),
            ('curveTo', 57.2861, 13.724, 58.9987, 13.0817, 60.2418, 11.7971),
            ('curveTo', 61.485, 10.5126, 62.1065, 8.75154, 62.1065, 6.51392),
            'closePath',
            ('moveTo', 56.7336, 6.67551),
            ('curveTo', 56.7336, 7.17276, 56.6968, 7.62236, 56.6231, 8.02428),
            ('curveTo', 56.5494, 8.42623, 56.4433, 8.77016, 56.3054, 9.05607),
            ('curveTo', 56.1672, 9.34198, 56.0013, 9.56369, 55.808, 9.72113),
            ('curveTo', 55.6147, 9.8786, 55.3982, 9.95733, 55.1589, 9.95733),
            ('curveTo', 54.6892, 9.95733, 54.3117, 9.65898, 54.0262, 9.06229),
            ('curveTo', 53.7407, 8.54018, 53.5981, 7.75702, 53.5981, 6.71282),
            ('curveTo', 53.5981, 5.68515, 53.7407, 4.90202, 54.0262, 4.36332),
            ('curveTo', 54.3117, 3.76663, 54.6939, 3.46828, 55.1728, 3.46828),
            ('curveTo', 55.6239, 3.46828, 55.9969, 3.7625, 56.2916, 4.35088),
            ('curveTo', 56.5862, 5.0056, 56.7336, 5.78047, 56.7336, 6.67551),
            'closePath',
            ('moveTo', 69.7863, 0),
            ('lineTo', 64.2475, 0),
            ('lineTo', 64.2475, 13.438),
            ('lineTo', 69.7863, 13.438),
            ('lineTo', 69.496, 10.8151),
            ('curveTo', 70.3341, 12.7792, 71.7199, 13.7613, 73.6535, 13.7613),
            ('lineTo', 73.6535, 8.16725),
            ('curveTo', 73.0459, 8.4656, 72.5302, 8.61478, 72.1065, 8.61478),
            ('curveTo', 71.3607, 8.61478, 70.7876, 8.37236, 70.3871, 7.88755),
            ('curveTo', 69.9864, 7.40274, 69.7863, 6.69623, 69.7863, 5.76804),
            'closePath',
            ('moveTo', 81.5543, 0),
            ('lineTo', 76.0016, 0),
            ('lineTo', 76.0016, 9.42278),
            ('lineTo', 74.4273, 9.42278),
            ('lineTo', 74.4273, 13.438),
            ('lineTo', 76.0016, 13.438),
            ('lineTo', 76.0016, 17.3911),
            ('lineTo', 81.5543, 17.3911),
            ('lineTo', 81.5543, 13.438),
            ('lineTo', 83.3912, 13.438),
            ('lineTo', 83.3912, 9.42278),
            ('lineTo', 81.5543, 9.42278),
            'closePath',
            ('moveTo', 95.1733, 0),
            ('lineTo', 85.0902, 0),
            ('lineTo', 85.0902, 19.1937),
            ('lineTo', 90.85, 19.1937),
            ('lineTo', 90.85, 4.61196),
            ('lineTo', 95.1733, 4.61196),
            'closePath',
            ('moveTo', 110.008, 0),
            ('lineTo', 104.455, 0),
            ('curveTo', 104.501, 0.44754, 104.538, 0.87433, 104.566, 1.2804),
            ('curveTo', 104.593, 1.68651, 104.621, 2.01385, 104.649, 2.26246),
            ('curveTo', 103.691, 0.57182, 102.406, -0.27348, 100.795, -0.27348),
            ('curveTo', 99.3953, -0.27348, 98.2856, 0.35637, 97.4661, 1.61605),
            ('curveTo', 96.6558, 2.86746, 96.2506, 4.59952, 96.2506, 6.81227),
            ('curveTo', 96.2506, 8.95041, 96.6696, 10.6328, 97.5076, 11.8593),
            ('curveTo', 98.3454, 13.1024, 99.4872, 13.724, 100.933, 13.724),
            ('curveTo', 102.416, 13.724, 103.612, 12.9201, 104.524, 11.3123),
            ('curveTo', 104.506, 11.4781, 104.492, 11.6231, 104.483, 11.7474),
            ('curveTo', 104.474, 11.8717, 104.464, 11.9753, 104.455, 12.0582),
            ('lineTo', 104.4, 12.8414),
            ('lineTo', 104.359, 13.438),
            ('lineTo', 110.008, 13.438),
            'closePath',
            ('moveTo', 104.4, 6.88685),
            ('curveTo', 104.4, 7.38409, 104.379, 7.80676, 104.338, 8.15481),
            ('curveTo', 104.296, 8.5029, 104.23, 8.78672, 104.138, 9.00636),
            ('curveTo', 104.045, 9.22598, 103.926, 9.38341, 103.778, 9.47874),
            ('curveTo', 103.631, 9.57403, 103.452, 9.62168, 103.24, 9.62168),
            ('curveTo', 102.3, 9.62168, 101.831, 8.49875, 101.831, 6.25285),
            ('curveTo', 101.831, 4.64508, 102.25, 3.8412, 103.088, 3.8412),
            ('curveTo', 103.963, 3.8412, 104.4, 4.85641, 104.4, 6.88685),
            'closePath',
            ('moveTo', 118.226, 0),
            ('lineTo', 112.563, 0),
            ('lineTo', 112.563, 20.9962),
            ('lineTo', 118.102, 20.9962),
            ('lineTo', 118.102, 13.6369),
            ('curveTo', 118.102, 13.0154, 118.074, 12.3027, 118.019, 11.4988),
            ('curveTo', 118.525, 12.311, 119.036, 12.8869, 119.552, 13.2267),
            ('curveTo', 120.086, 13.5582, 120.758, 13.724, 121.569, 13.724),
            ('curveTo', 123.079, 13.724, 124.248, 13.0983, 125.077, 11.8469),
            ('curveTo', 125.906, 10.6037, 126.32, 8.85099, 126.32, 6.5885),
            ('curveTo', 126.32, 4.42546, 125.892, 2.74314, 125.036, 1.54147),
            ('curveTo', 124.188, 0.3315, 123.014, -0.27348, 121.513, -0.27348),
            ('curveTo', 120.786, -0.27348, 120.169, -0.12432, 119.663, 0.17403),
            ('curveTo', 119.414, 0.3315, 119.158, 0.54283, 118.896, 0.80803),
            ('curveTo', 118.634, 1.07322, 118.369, 1.40472, 118.102, 1.80252),
            ('curveTo', 118.111, 1.64505, 118.12, 1.51039, 118.129, 1.3985),
            ('curveTo', 118.139, 1.28662, 118.148, 1.19339, 118.157, 1.11881),
            'closePath',
            ('moveTo', 120.588, 6.70038),
            ('curveTo', 120.588, 8.62306, 120.118, 9.5844, 119.179, 9.5844),
            ('curveTo', 118.35, 9.5844, 117.936, 8.67693, 117.936, 6.86198),
            ('curveTo', 117.936, 4.96417, 118.364, 4.01526, 119.221, 4.01526),
            ('curveTo', 120.132, 4.01526, 120.588, 4.91027, 120.588, 6.70038),
            'closePath'] + []
        g.add(definePath(P, strokeColor = strokeColor, strokeWidth = strokeWidth, fillColor = fillColor, dx = dx, dy = dy))

    
    def draw(self):
        fillColor = self.fillColor
        strokeColor = self.strokeColor
        g = Group()
        bg = self.background
        bd = self.border
        bdw = self.borderWidth
        shadow = self.shadow
        x = self.x
        y = self.y
        if bg:
            if shadow is not None:
                if shadow <= shadow:
                    pass
                elif shadow < 1:
                    shadow = Color(bg.red * shadow, bg.green * shadow, bg.blue * shadow)
                
            self._paintLogo(g, dy = -2.5, dx = 2, fillColor = shadow)
        
        self._paintLogo(g, fillColor = fillColor, strokeColor = strokeColor)
        g.skew(kx = self.skewX, ky = self.skewY)
        g.shift(self._dx, self._dy)
        G = Group()
        G.add(g)
        (_w, _h) = (130, 86)
        w = self.width
        h = self.height
        if (bg or bd) and bdw:
            G.insert(0, Rect(0, 0, _w, _h, fillColor = bg, strokeColor = bd, strokeWidth = bdw))
        
        if w != _w or h != _h:
            G.scale(w / float(_w), h / float(_h))
        
        angle = self.angle
        if self.angle:
            w = w / 2
            h = h / 2
            G.shift(-w, -h)
            G.rotate(angle)
            G.shift(w, h)
        
        if not getattr(self, 'xFlip', 0) or -1:
            pass
        xFlip = 0
        if not getattr(self, 'yFlip', 0) or -1:
            pass
        yFlip = 0
        if xFlip or yFlip:
            if not xFlip:
                pass
            sx = 1
            if not yFlip:
                pass
            sy = 1
            G.shift(sx * x + w * xFlip, sy * y + yFlip * h)
            G = Group(G, transform = (sx, 0, 0, sy, 0, 0))
        else:
            G.shift(x, y)
        return G



class RL_CorpLogoReversed(RL_CorpLogo):
    
    def __init__(self):
        RL_CorpLogo.__init__(self)
        self.background = white
        self.fillColor = ReportLabBlue



class RL_CorpLogoThin(Widget):
    '''The ReportLab Logo.

    New version created by John Precedo on 7-8 August 2001.
    Based on bitmapped imaged from E-Id.
    Improved by Robin Becker.'''
    _attrMap = AttrMap(x = AttrMapValue(isNumber), y = AttrMapValue(isNumber), height = AttrMapValue(isNumberOrNone), width = AttrMapValue(isNumberOrNone), fillColor = AttrMapValue(isColorOrNone), strokeColor = AttrMapValue(isColorOrNone))
    _h = 90.5
    _w = 136.5
    _text = 'R e p o r t L a b'
    _fontName = 'Helvetica-Bold'
    _fontSize = 16
    
    def __init__(self):
        self.fillColor = ReportLabBlue
        self.strokeColor = white
        self.x = 0
        self.y = 0
        self.height = self._h
        self.width = self._w

    
    def demo(self):
        D = Drawing(self.width, self.height)
        D.add(self)
        return D

    
    def _getText(self, x = 0, y = 0, color = None):
        return String(x, y, self._text, fontName = self._fontName, fontSize = self._fontSize, fillColor = color)

    
    def _sw(self, f = None, l = None):
        text = self._text
        if f is None:
            f = 0
        
        if l is None:
            l = len(text)
        
        return stringWidth(text[f:l], self._fontName, self._fontSize)

    
    def _addPage(self, g, strokeWidth = 3, color = None, dx = 0, dy = 0):
        x1 = 31.85 + dx
        x2 = 80.97 + dx
        fL = 10
        y1 = dy - 34
        y2 = dy + 50.5
        L = [
            [
                x1,
                dy - 4,
                x1,
                y1,
                x2,
                y1,
                x2,
                dy - 1],
            [
                x1,
                dy + 11,
                x1,
                y2,
                x2 - fL,
                y2,
                x2,
                y2 - fL,
                x2,
                dy + 14],
            [
                x2 - 10,
                y2,
                x2 - 10,
                y2 - fL,
                x2,
                y2 - fL]]
        for l in L:
            g.add(PolyLine(l, strokeWidth = strokeWidth, strokeColor = color, strokeLineJoin = 0))
        

    
    def draw(self):
        sx = 0.5
        fillColor = self.fillColor
        strokeColor = self.strokeColor
        shadow = Color(fillColor.red * sx, fillColor.green * sx, fillColor.blue * sx)
        g = Group()
        g2 = Group()
        g.add(Rect(fillColor = fillColor, strokeColor = fillColor, x = 0, y = 0, width = self._w, height = self._h))
        sx = (self._w - 2) / self._sw()
        g2.scale(sx, 1)
        self._addPage(g2, strokeWidth = 3, dx = 2, dy = -2.5, color = shadow)
        self._addPage(g2, strokeWidth = 3, color = strokeColor)
        g2.scale(1 / sx, 1)
        g2.add(self._getText(x = 1, y = 0, color = shadow))
        g2.add(self._getText(x = 0, y = 1, color = strokeColor))
        g2.scale(sx, 1)
        g2.skew(kx = 10, ky = 0)
        g2.shift(0, 38)
        g.add(g2)
        g.scale(self.width / self._w, self.height / self._h)
        g.shift(self.x, self.y)
        return g



class ReportLabLogo:
    '''vector reportlab logo centered in a 250x by 150y rectangle'''
    
    def __init__(self, atx = 0, aty = 0, width = 2.5 * inch, height = 1.5 * inch, powered_by = 0):
        self.origin = (atx, aty)
        self.dimensions = (width, height)
        self.powered_by = powered_by

    
    def draw(self, canvas):
        renderPDF = renderPDF
        import reportlab.graphics
        canvas.saveState()
        (atx, aty) = self.origin
        (width, height) = self.dimensions
        logo = RL_CorpLogo()
        logo.width = width
        logo.height = height
        renderPDF.draw(logo.demo(), canvas, atx, aty, 0)
        canvas.restoreState()



class RL_BusinessCard(Widget):
    '''Widget that creates a single business card.
    Uses RL_CorpLogo for the logo.

    For a black border around your card, set self.border to 1.
    To change the details on the card, over-ride the following properties:
    self.name, self.position, self.telephone, self.mobile, self.fax, self.email, self.web
    The office locations are set in self.rh_blurb_top ("London office" etc), and
    self.rh_blurb_bottom ("New York office" etc).
    '''
    _attrMap = AttrMap(fillColor = AttrMapValue(isColorOrNone), strokeColor = AttrMapValue(isColorOrNone), altStrokeColor = AttrMapValue(isColorOrNone), x = AttrMapValue(isNumber), y = AttrMapValue(isNumber), height = AttrMapValue(isNumber), width = AttrMapValue(isNumber), borderWidth = AttrMapValue(isNumber), bleed = AttrMapValue(isNumberOrNone), cropMarks = AttrMapValue(isBoolean), border = AttrMapValue(isBoolean), name = AttrMapValue(isString), position = AttrMapValue(isString), telephone = AttrMapValue(isString), mobile = AttrMapValue(isString), fax = AttrMapValue(isString), email = AttrMapValue(isString), web = AttrMapValue(isString), rh_blurb_top = AttrMapValue(isListOfStringsOrNone), rh_blurb_bottom = AttrMapValue(isListOfStringsOrNone))
    _h = 5.35 * cm
    _w = 8.5 * cm
    _fontName = 'Helvetica-Bold'
    _strapline = 'strategic reporting solutions for e-business'
    
    def __init__(self):
        self.fillColor = ReportLabBlue
        self.strokeColor = black
        self.altStrokeColor = white
        self.x = 0
        self.y = 0
        self.height = self._h
        self.width = self._w
        self.borderWidth = self.width / 6.15
        self.bleed = 0.2 * cm
        self.cropMarks = 1
        self.border = 0
        self.name = 'Joe Cool'
        self.position = 'Freelance Demonstrator'
        self.telephone = '020 8545 7271'
        self.mobile = '-'
        self.fax = '020 8544 1311'
        self.email = 'info@reportlab.com'
        self.web = 'www.reportlab.com'
        self.rh_blurb_top = [
            'London office:',
            'ReportLab Europe Ltd',
            'Lombard Business Park',
            '8 Lombard Road',
            'Wimbledon',
            'London SW19 3TZ',
            'United Kingdom']
        self.rh_blurb_bottom = [
            'New York office:',
            'ReportLab Inc',
            '219 Harper Street',
            'Highland Park',
            'New Jersey  08904',
            'USA']

    
    def demo(self):
        D = Drawing(self.width, self.height)
        D.add(self)
        return D

    
    def draw(self):
        fillColor = self.fillColor
        strokeColor = self.strokeColor
        g = Group()
        g.add(Rect(x = 0, y = 0, fillColor = self.fillColor, strokeColor = self.fillColor, width = self.borderWidth, height = self.height))
        g.add(Rect(x = 0, y = self.height - self.borderWidth, fillColor = self.fillColor, strokeColor = self.fillColor, width = self.width, height = self.borderWidth))
        g2 = Group()
        rl = RL_CorpLogo()
        rl.height = 1.25 * cm
        rl.width = 1.9 * cm
        rl.draw()
        g2.add(rl)
        g.add(g2)
        g2.shift(x = self.width - (rl.width + self.width / 42), y = self.height - (rl.height + self.height / 42))
        g.add(String(x = self.borderWidth / 5, y = (self.height - (rl.height + self.height / 42)) + (38 / 90.5) * rl.height, fontSize = 6, fillColor = self.altStrokeColor, fontName = 'Helvetica-BoldOblique', textAnchor = 'start', text = self._strapline))
        leftText = [
            'Tel:',
            'Mobile:',
            'Fax:',
            'Email:',
            'Web:']
        leftDetails = [
            self.telephone,
            self.mobile,
            self.fax,
            self.email,
            self.web]
        leftText.reverse()
        leftDetails.reverse()
        for f in range(len(leftText), 0, -1):
            g.add(String(x = self.borderWidth + self.borderWidth / 5, y = self.borderWidth / 5 + (f - 1) * 6, fontSize = 5, fillColor = self.strokeColor, fontName = 'Helvetica', textAnchor = 'start', text = leftText[f - 1]))
            g.add(String(x = self.borderWidth + self.borderWidth / 5 + self.borderWidth, y = self.borderWidth / 5 + (f - 1) * 6, fontSize = 5, fillColor = self.strokeColor, fontName = 'Helvetica', textAnchor = 'start', text = leftDetails[f - 1]))
        
        rightText = self.rh_blurb_bottom
        rightText.reverse()
        for f in range(len(rightText), 0, -1):
            g.add(String(x = self.width - self.borderWidth / 5, y = self.borderWidth / 5 + (f - 1) * 6, fontSize = 5, fillColor = self.strokeColor, fontName = 'Helvetica', textAnchor = 'end', text = rightText[f - 1]))
        
        ty = (self.height - self.borderWidth - self.borderWidth / 5) + 2
        rightText = self.rh_blurb_top
        for f in range(1, len(rightText) + 1):
            g.add(String(x = self.width - self.borderWidth / 5, y = ty - f * 6, fontSize = 5, fillColor = self.strokeColor, fontName = 'Helvetica', textAnchor = 'end', text = rightText[f - 1]))
        
        g.add(String(x = self.borderWidth + self.borderWidth / 5, y = ty - 10, fontSize = 10, fillColor = self.strokeColor, fontName = 'Helvetica', textAnchor = 'start', text = self.name))
        ty1 = ty - 12
        g.add(String(x = self.borderWidth + self.borderWidth / 5, y = ty1 - 8, fontSize = 8, fillColor = self.strokeColor, fontName = 'Helvetica', textAnchor = 'start', text = self.position))
        if self.border:
            g.add(Rect(x = 0, y = 0, fillColor = None, strokeColor = black, width = self.width, height = self.height))
        
        g.shift(self.x, self.y)
        return g



def test():
    '''This function produces a pdf with examples. '''
    rl = RL_CorpLogo()
    rl.width = 129
    rl.height = 86
    D = Drawing(rl.width, rl.height)
    D.add(rl)
    D.__dict__['verbose'] = 1
    D.save(fnRoot = 'corplogo_whiteonblue', formats = [
        'pdf',
        'eps',
        'jpg',
        'gif'])
    rl = RL_CorpLogoReversed()
    rl.width = 129
    rl.height = 86
    D = Drawing(rl.width, rl.height)
    D.add(rl)
    D.__dict__['verbose'] = 1
    D.save(fnRoot = 'corplogo_blueonwhite', formats = [
        'pdf',
        'eps',
        'jpg',
        'gif'])
    rl = RL_CorpLogoReversed()
    rl.fillColor = Color(0.2, 0.2, 0.2)
    rl.width = 129
    rl.height = 86
    D = Drawing(rl.width, rl.height)
    D.add(rl)
    D.__dict__['verbose'] = 1
    D.save(fnRoot = 'corplogo_grayonwhite', formats = [
        'pdf',
        'eps',
        'jpg',
        'gif'])
    rl = RL_BusinessCard()
    rl.x = 25
    rl.y = 25
    rl.border = 1
    D = Drawing(rl.width + 50, rl.height + 50)
    D.add(rl)
    D.__dict__['verbose'] = 1
    D.save(fnRoot = 'RL_BusinessCard', formats = [
        'pdf'])

if __name__ == '__main__':
    test()

