# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

__version__ = ' $Id: _cidfontdata.py 2901 2006-05-22 23:02:22Z andy $ '
__doc__ = "\nThis defines additional static data to support CID fonts.\n\nCanned data is provided for the Japanese fonts supported by Adobe. We\ncan add Chinese, Korean and Vietnamese in due course. The data was\nextracted by creating very simple postscript documents and running\nthrough Distiller, then examining the resulting PDFs.\n\nEach font is described as a big nested dictionary.  This lets us keep\ncode out of the module altogether and avoid circular dependencies.\n\nThe encoding and font data are grouped by some standard 'language\nprefixes':\n   chs = Chinese Simplified (mainland)\n   cht = Chinese Traditional (Taiwan)\n   kor = Korean\n   jpn = Japanese\n"
languages = [
    'jpn',
    'kor',
    'cht',
    'chs']
typeFaces_chs = [
    'STSong-Light']
typeFaces_cht = [
    'MSung-Light']
typeFaces_jpn = [
    'HeiseiMin-W3',
    'HeiseiKakuGo-W5']
typeFaces_kor = [
    'HYSMyeongJo-Medium',
    'HYGothic-Medium']
allowedTypeFaces = typeFaces_chs + typeFaces_cht + typeFaces_jpn + typeFaces_kor
encodings_jpn = [
    '83pv-RKSJ-H',
    '90ms-RKSJ-H',
    '90ms-RKSJ-V',
    '90msp-RKSJ-H',
    '90msp-RKSJ-V',
    '90pv-RKSJ-H',
    'Add-RKSJ-H',
    'Add-RKSJ-V',
    'EUC-H',
    'EUC-V',
    'Ext-RKSJ-H',
    'Ext-RKSJ-V',
    'H',
    'V',
    'UniJIS-UCS2-H',
    'UniJIS-UCS2-V',
    'UniJIS-UCS2-HW-H',
    'UniJIS-UCS2-HW-V']
encodings_kor = [
    'KSC-EUC-H',
    'KSC-EUC-V',
    'KSCms-UHC-H',
    'KSCms-UHC-V',
    'KSCms-UHC-HW-H',
    'KSCms-UHC-HW-V',
    'KSCpc-EUC-H',
    'UniKS-UCS2-H',
    'UniKS-UCS2-V']
encodings_chs = [
    'GB-EUC-H',
    'GB-EUC-V',
    'GBpc-EUC-H',
    'GBpc-EUC-V',
    'GBK-EUC-H',
    'GBK-EUC-V',
    'UniGB-UCS2-H',
    'UniGB-UCS2-V']
encodings_cht = [
    'B5pc-H',
    'B5pc-V',
    'ETen-B5-H',
    'ETen-B5-V',
    'ETenms-B5-H',
    'ETenms-B5-V',
    'CNS-EUC-H',
    'CNS-EUC-V',
    'UniCNS-UCS2-H',
    'UniCNS-UCS2-V']
allowedEncodings = [
    'Identity-H',
    'Identity-V'] + encodings_chs + encodings_cht + encodings_jpn + encodings_kor
defaultUnicodeEncodings = {
    'HeiseiMin-W3': ('jpn', 'UniJIS-UCS2-H'),
    'HeiseiKakuGo-W5': ('jpn', 'UniJIS-UCS2-H'),
    'STSong-Light': ('chs', 'UniGB-UCS2-H'),
    'MSung-Light': ('cht', 'UniGB-UCS2-H'),
    'HYSMyeongJo-Medium': ('kor', 'UniKS-UCS2-H'),
    'HYGothic-Medium': ('kor', 'UniKS-UCS2-H') }
typeFaces_chs = [
    'STSong-Light']
typeFaces_cht = [
    'MSung-Light',
    'MHei-Medium']
typeFaces_jpn = [
    'HeiseiMin-W3',
    'HeiseiKakuGo-W5']
typeFaces_kor = [
    'HYSMyeongJo-Medium',
    'HYGothic-Medium']
unicode_encodings = [] if 'UCS2' in enc else _[1]
CIDFontInfo = { }
CIDFontInfo['HeiseiMin-W3'] = {
    'Type': '/Font',
    'Subtype': '/Type0',
    'Name': '/%(internalName)s',
    'BaseFont': '/HeiseiMin-W3',
    'Encoding': '/%(encodings)s',
    'DescendantFonts': [
        {
            'Type': '/Font',
            'Subtype': '/CIDFontType0',
            'BaseFont': '/HeiseiMin-W3',
            'FontDescriptor': {
                'Type': '/FontDescriptor',
                'Ascent': 723,
                'CapHeight': 709,
                'Descent': -241,
                'Flags': 6,
                'FontBBox': (-123, -257, 1001, 910),
                'FontName': '/HeiseiMin-W3',
                'ItalicAngle': 0,
                'StemV': 69,
                'XHeight': 450 },
            'CIDSystemInfo': {
                'Registry': '(Adobe)',
                'Ordering': '(Japan1)',
                'Supplement': 2 },
            'DW': 1000,
            'W': [
                1,
                [
                    250,
                    333,
                    408,
                    500],
                5,
                [
                    500,
                    833,
                    778,
                    180,
                    333],
                10,
                [
                    333,
                    500,
                    564,
                    250,
                    333,
                    250,
                    278,
                    500],
                18,
                26,
                500,
                27,
                28,
                278,
                29,
                31,
                564,
                32,
                [
                    444,
                    921,
                    722,
                    667],
                36,
                [
                    667,
                    722,
                    611,
                    556,
                    722],
                41,
                [
                    722,
                    333,
                    389,
                    722,
                    611,
                    889,
                    722],
                48,
                [
                    722,
                    556,
                    722,
                    667,
                    556,
                    611,
                    722],
                55,
                [
                    722,
                    944,
                    722],
                58,
                [
                    722,
                    611,
                    333,
                    500,
                    333,
                    469,
                    500,
                    333,
                    444,
                    500,
                    444,
                    500,
                    444,
                    333,
                    500],
                73,
                [
                    500,
                    278],
                75,
                [
                    278,
                    500,
                    278,
                    778,
                    500],
                80,
                82,
                500,
                83,
                [
                    333,
                    389,
                    278,
                    500],
                87,
                [
                    500,
                    722,
                    500],
                90,
                [
                    500,
                    444,
                    480,
                    200,
                    480,
                    333],
                97,
                [
                    278],
                99,
                [
                    200],
                101,
                [
                    333,
                    500],
                103,
                [
                    500,
                    167],
                107,
                [
                    500],
                109,
                [
                    500,
                    333],
                111,
                [
                    333,
                    556],
                113,
                [
                    556,
                    500],
                117,
                [
                    250],
                119,
                [
                    350,
                    333,
                    444],
                123,
                [
                    500],
                126,
                [
                    444,
                    333],
                128,
                137,
                333,
                138,
                [
                    1000,
                    889,
                    276,
                    611,
                    722,
                    889,
                    310,
                    667,
                    278],
                147,
                [
                    278,
                    500,
                    722,
                    500,
                    564,
                    760,
                    564,
                    760],
                157,
                158,
                300,
                159,
                [
                    500,
                    300,
                    750],
                162,
                163,
                750,
                164,
                169,
                722,
                170,
                [
                    667,
                    611],
                172,
                174,
                611,
                175,
                178,
                333,
                179,
                185,
                722,
                187,
                191,
                722,
                192,
                [
                    556,
                    444],
                194,
                203,
                444,
                204,
                207,
                278,
                208,
                214,
                500,
                216,
                222,
                500,
                223,
                [
                    556,
                    722,
                    611,
                    500,
                    389,
                    980,
                    444],
                231,
                [
                    500],
                323,
                [
                    500],
                325,
                [
                    500],
                327,
                389,
                500] }] }
CIDFontInfo['HeiseiKakuGo-W5'] = {
    'Type': '/Font',
    'Subtype': '/Type0',
    'Name': '/%(internalName)s',
    'BaseFont': '/HeiseiKakuGo-W5',
    'Encoding': '/%(encodings)s',
    'DescendantFonts': [
        {
            'Type': '/Font',
            'Subtype': '/CIDFontType0',
            'BaseFont': '/HeiseiKakuGo-W5',
            'FontDescriptor': {
                'Type': '/FontDescriptor',
                'Ascent': 752,
                'CapHeight': 737,
                'Descent': -221,
                'Flags': 4,
                'FontBBox': [
                    -92,
                    -250,
                    1010,
                    922],
                'FontName': '/HeiseKakuGo-W5',
                'ItalicAngle': 0,
                'StemH': 0,
                'StemV': 114,
                'XHeight': 553 },
            'CIDSystemInfo': {
                'Registry': '(Adobe)',
                'Ordering': '(Japan1)',
                'Supplement': 2 },
            'DW': 1000,
            'W': (1, (277, 305, 500, 668, 668, 906, 727, 305, 445, 445, 508, 668, 305, 379, 305, 539), 17, 26, 668, 27, (305, 305, 668, 668, 668, 566, 871, 727, 637, 652, 699, 574, 555, 676, 687, 242, 492, 664, 582, 789, 707, 734, 582, 734, 605, 605, 641, 668, 727, 945, 609, 609, 574, 445, 668, 445, 668, 668, 590, 555, 609, 547, 602, 574, 391, 609, 582, 234, 277, 539, 234, 895, 582, 605, 602, 602, 387, 508, 441, 582, 562, 781, 531, 570, 555, 449, 246, 449, 668), 231, 632, 500) }] }
CIDFontInfo['HYGothic-Medium'] = {
    'Type': '/Font',
    'Subtype': '/Type0',
    'Name': '/%(internalName)s',
    'BaseFont': '/' + 'HYGothic-Medium',
    'Encoding': '/%(encodings)s',
    'DescendantFonts': [
        {
            'Type': '/Font',
            'Subtype': '/CIDFontType0',
            'BaseFont': '/' + 'HYGothic-Medium',
            'FontDescriptor': {
                'Type': '/FontDescriptor',
                'Ascent': 752,
                'AvgWidth': -271,
                'CapHeight': 737,
                'Descent': -142,
                'Flags': 6,
                'FontBBox': [
                    -6,
                    -145,
                    1003,
                    880],
                'FontName': '/' + 'HYSMyeongJo-Medium',
                'ItalicAngle': 0,
                'Leading': 148,
                'MaxWidth': 1000,
                'MissingWidth': 500,
                'StemH': 0,
                'StemV': 58,
                'XHeight': 553 },
            'CIDSystemInfo': {
                'Registry': '(Adobe)',
                'Ordering': '(Korea1)',
                'Supplement': 1 },
            'DW': 1000,
            'W': (1, 94, 500) }] }
CIDFontInfo['HYSMyeongJo-Medium'] = {
    'Type': '/Font',
    'Subtype': '/Type0',
    'Name': '/%(internalName)s',
    'BaseFont': '/' + 'HYSMyeongJo-Medium',
    'Encoding': '/%(encodings)s',
    'DescendantFonts': [
        {
            'Type': '/Font',
            'Subtype': '/CIDFontType2',
            'BaseFont': '/' + 'HYSMyeongJo-Medium',
            'FontDescriptor': {
                'Type': '/FontDescriptor',
                'Ascent': 752,
                'AvgWidth': 500,
                'CapHeight': 737,
                'Descent': -271,
                'Flags': 6,
                'FontBBox': [
                    0,
                    -148,
                    1001,
                    880],
                'FontName': '/' + 'HYSMyeongJo-Medium',
                'ItalicAngle': 0,
                'Leading': 148,
                'MaxWidth': 1000,
                'MissingWidth': 500,
                'StemH': 91,
                'StemV': 58,
                'XHeight': 553 },
            'CIDSystemInfo': {
                'Registry': '(Adobe)',
                'Ordering': '(Korea1)',
                'Supplement': 1 },
            'DW': 1000,
            'W': [
                1,
                [
                    333,
                    416],
                3,
                [
                    416,
                    833,
                    625,
                    916,
                    833,
                    250,
                    500],
                10,
                11,
                500,
                12,
                [
                    833,
                    291,
                    833,
                    291,
                    375,
                    625],
                18,
                26,
                625,
                27,
                28,
                333,
                29,
                30,
                833,
                31,
                [
                    916,
                    500,
                    1000,
                    791,
                    708],
                36,
                [
                    708,
                    750,
                    708,
                    666,
                    750,
                    791,
                    375,
                    500,
                    791,
                    666,
                    916,
                    791,
                    750,
                    666,
                    750,
                    708,
                    666,
                    791],
                54,
                [
                    791,
                    750,
                    1000,
                    708],
                58,
                [
                    708,
                    666,
                    500,
                    375,
                    500],
                63,
                64,
                500,
                65,
                [
                    333,
                    541,
                    583,
                    541,
                    583],
                70,
                [
                    583,
                    375,
                    583],
                73,
                [
                    583,
                    291,
                    333,
                    583,
                    291,
                    875,
                    583],
                80,
                82,
                583,
                83,
                [
                    458,
                    541,
                    375,
                    583],
                87,
                [
                    583,
                    833,
                    625],
                90,
                [
                    625,
                    500,
                    583],
                93,
                94,
                583,
                95,
                [
                    750]] }] }
CIDFontInfo['STSong-Light'] = {
    'Type': '/Font',
    'Subtype': '/Type0',
    'Name': '/%(internalName)s',
    'BaseFont': '/' + 'STSong-Light',
    'Encoding': '/%(encodings)s',
    'DescendantFonts': [
        {
            'Type': '/Font',
            'Subtype': '/CIDFontType0',
            'BaseFont': '/' + 'STSong-Light',
            'FontDescriptor': {
                'Type': '/FontDescriptor',
                'Ascent': 752,
                'CapHeight': 737,
                'Descent': -271,
                'Flags': 6,
                'FontBBox': [
                    -25,
                    -254,
                    1000,
                    880],
                'FontName': '/' + 'STSongStd-Light',
                'ItalicAngle': 0,
                'Leading': 148,
                'MaxWidth': 1000,
                'MissingWidth': 500,
                'StemH': 91,
                'StemV': 58,
                'XHeight': 553 },
            'CIDSystemInfo': {
                'Registry': '(Adobe)',
                'Ordering': '(GB1)',
                'Supplement': 0 },
            'DW': 1000,
            'W': [
                1,
                [
                    207,
                    270,
                    342,
                    467,
                    462,
                    797,
                    710,
                    239,
                    374],
                10,
                [
                    374,
                    423,
                    605,
                    238,
                    375,
                    238,
                    334,
                    462],
                18,
                26,
                462,
                27,
                28,
                238,
                29,
                31,
                605,
                32,
                [
                    344,
                    748,
                    684,
                    560,
                    695,
                    739,
                    563,
                    511,
                    729,
                    793,
                    318,
                    312,
                    666,
                    526,
                    896,
                    758,
                    772,
                    544,
                    772,
                    628,
                    465,
                    607,
                    753,
                    711,
                    972,
                    647,
                    620,
                    607,
                    374,
                    333,
                    374,
                    606,
                    500,
                    239,
                    417,
                    503,
                    427,
                    529,
                    415,
                    264,
                    444,
                    518,
                    241,
                    230,
                    495,
                    228,
                    793,
                    527,
                    524],
                81,
                [
                    524,
                    504,
                    338,
                    336,
                    277,
                    517,
                    450,
                    652,
                    466,
                    452,
                    407,
                    370,
                    258,
                    370,
                    605]] }] }
CIDFontInfo['MSung-Light'] = {
    'Type': '/Font',
    'Subtype': '/Type0',
    'Name': '/%(internalName)s',
    'BaseFont': '/' + 'MSung-Light',
    'Encoding': '/%(encodings)s',
    'DescendantFonts': [
        {
            'Type': '/Font',
            'Subtype': '/CIDFontType0',
            'BaseFont': '/' + 'MSung-Light',
            'FontDescriptor': {
                'Type': '/FontDescriptor',
                'Ascent': 752,
                'CapHeight': 737,
                'Descent': -271,
                'Flags': 6,
                'FontBBox': [
                    -160,
                    -249,
                    1015,
                    888],
                'FontName': '/' + 'MSung-Light',
                'ItalicAngle': 0,
                'Leading': 148,
                'MaxWidth': 1000,
                'MissingWidth': 500,
                'StemH': 45,
                'StemV': 58,
                'XHeight': 553 },
            'CIDSystemInfo': {
                'Registry': '(Adobe)',
                'Ordering': '(CNS1)',
                'Supplement': 1 },
            'DW': 1000,
            'W': [
                1,
                2,
                250,
                3,
                [
                    408,
                    668,
                    490,
                    875,
                    698,
                    250,
                    240],
                10,
                [
                    240,
                    417,
                    667,
                    250,
                    313,
                    250,
                    520,
                    500],
                18,
                26,
                500,
                27,
                28,
                250,
                29,
                31,
                667,
                32,
                [
                    396,
                    921,
                    677,
                    615,
                    719,
                    760,
                    625,
                    552,
                    771,
                    802,
                    354],
                43,
                [
                    354,
                    781,
                    604,
                    927,
                    750,
                    823,
                    563,
                    823,
                    729,
                    542,
                    698,
                    771,
                    729,
                    948,
                    771,
                    677,
                    635,
                    344,
                    520,
                    344,
                    469,
                    500,
                    250,
                    469,
                    521,
                    427,
                    521,
                    438,
                    271,
                    469,
                    531,
                    250],
                75,
                [
                    250,
                    458,
                    240,
                    802,
                    531,
                    500,
                    521],
                82,
                [
                    521,
                    365,
                    333,
                    292,
                    521,
                    458,
                    677,
                    479,
                    458,
                    427,
                    480,
                    496,
                    480,
                    667]] }] }
widthsByUnichar = { }
widthsByUnichar['MSung-Light'] = {
    u' ': 250,
    u'$': 490,
    u'(': 240,
    u',': 250,
    u'0': 500,
    u'4': 500,
    u'8': 500,
    u'<': 667,
    u'@': 921,
    u'D': 760,
    u'H': 802,
    u'L': 604,
    u'P': 563,
    u'T': 698,
    u'X': 771,
    u'\\': 520,
    u'`': 250,
    u'd': 521,
    u'h': 531,
    u'l': 240,
    u'p': 521,
    u't': 292,
    u'x': 479,
    u'|': 496,
    u'#': 668,
    u"'": 250,
    u'+': 667,
    u'/': 520,
    u'3': 500,
    u'7': 500,
    u';': 250,
    u'?': 396,
    u'C': 719,
    u'G': 771,
    u'K': 781,
    u'O': 823,
    u'S': 542,
    u'W': 948,
    u'[': 344,
    u'_': 500,
    u'c': 427,
    u'g': 469,
    u'k': 458,
    u'o': 500,
    u's': 333,
    u'w': 677,
    u'{': 480,
    u'"': 408,
    u'&': 698,
    u'*': 417,
    u'.': 250,
    u'2': 500,
    u'6': 500,
    u':': 250,
    u'>': 667,
    u'B': 615,
    u'F': 552,
    u'J': 354,
    u'N': 750,
    u'R': 729,
    u'V': 729,
    u'Z': 635,
    u'^': 469,
    u'b': 521,
    u'f': 271,
    u'j': 250,
    u'n': 531,
    u'r': 365,
    u'v': 458,
    u'z': 427,
    u'~': 667,
    u'!': 250,
    u'%': 875,
    u')': 240,
    u'-': 313,
    u'1': 500,
    u'5': 500,
    u'9': 500,
    u'=': 667,
    u'A': 677,
    u'E': 625,
    u'I': 354,
    u'M': 927,
    u'Q': 823,
    u'U': 771,
    u'Y': 677,
    u']': 344,
    u'a': 469,
    u'e': 438,
    u'i': 250,
    u'm': 802,
    u'q': 521,
    u'u': 521,
    u'y': 458,
    u'}': 480 }
widthsByUnichar['HeiseiKakuGo-W5'] = {
    u'ﾁ': 500,
    u'ﾅ': 500,
    u'ﾉ': 500,
    u'ﾍ': 500,
    u'ﾑ': 500,
    u'ﾕ': 500,
    u'ﾙ': 500,
    u'ﾝ': 500,
    u' ': 277,
    u'$': 668,
    u'(': 445,
    u',': 305,
    u'0': 668,
    u'̲': 668,
    u'4': 668,
    u'8': 668,
    u'<': 668,
    u'@': 871,
    u'D': 699,
    u'H': 687,
    u'L': 582,
    u'P': 582,
    u'T': 641,
    u'X': 609,
    u'`': 590,
    u'｢': 500,
    u'd': 602,
    u'ｦ': 500,
    u'h': 582,
    u'ｪ': 500,
    u'l': 234,
    u'ｮ': 500,
    u'p': 602,
    u'ｲ': 500,
    u't': 441,
    u'ｶ': 500,
    u'x': 531,
    u'ｺ': 500,
    u'|': 246,
    u'ｾ': 500,
    u'ﾂ': 500,
    u'ﾆ': 500,
    u'ﾊ': 500,
    u'ﾎ': 500,
    u'ﾒ': 500,
    u'ﾖ': 500,
    u'ﾚ': 500,
    u'ﾞ': 500,
    u'#': 668,
    u"'": 305,
    u'+': 668,
    u'/': 539,
    u'3': 668,
    u'7': 668,
    u';': 305,
    u'?': 566,
    u'C': 652,
    u'G': 676,
    u'K': 664,
    u'O': 734,
    u'S': 605,
    u'W': 945,
    u'[': 445,
    u'_': 668,
    u'｡': 500,
    u'c': 547,
    u'･': 500,
    u'g': 609,
    u'ｩ': 500,
    u'k': 539,
    u'ｭ': 500,
    u'o': 605,
    u'ｱ': 500,
    u's': 508,
    u'ｵ': 500,
    u'w': 781,
    u'ｹ': 500,
    u'{': 449,
    u'ｽ': 500,
    u'̀': 590,
    u'ﾃ': 500,
    u' ': 500,
    u'ﾇ': 500,
    u'ﾋ': 500,
    u'ﾏ': 500,
    u'ﾓ': 500,
    u'ﾗ': 500,
    u'ﾛ': 500,
    u'ﾟ': 500,
    u'"': 500,
    u'¥': 668,
    u'&': 727,
    u'*': 508,
    u'.': 305,
    u'2': 668,
    u'6': 668,
    u':': 305,
    u'>': 668,
    u'B': 637,
    u'F': 555,
    u'J': 492,
    u'N': 707,
    u'‾': 500,
    u'R': 605,
    u'V': 727,
    u'Z': 574,
    u'^': 668,
    u'b': 609,
    u'､': 500,
    u'f': 391,
    u'ｨ': 500,
    u'j': 277,
    u'ｬ': 500,
    u'n': 582,
    u'ｰ': 500,
    u'r': 387,
    u'ｴ': 500,
    u'v': 562,
    u'ｸ': 500,
    u'z': 555,
    u'ｼ': 500,
    u'~': 668,
    u'ﾀ': 500,
    u'̃': 668,
    u'ﾄ': 500,
    u'ﾈ': 500,
    u'ﾌ': 500,
    u'‑': 379,
    u'ﾐ': 500,
    u'ﾔ': 500,
    u'ﾘ': 500,
    u'ﾜ': 500,
    u'!': 305,
    u'%': 906,
    u')': 445,
    u'-': 379,
    u'1': 668,
    u'5': 668,
    u'9': 668,
    u'=': 668,
    u'A': 727,
    u'E': 574,
    u'I': 242,
    u'M': 789,
    u'Q': 734,
    u'U': 668,
    u'Y': 609,
    u']': 445,
    u'a': 555,
    u'｣': 500,
    u'e': 574,
    u'ｧ': 500,
    u'i': 234,
    u'￨': 500,
    u'ｫ': 500,
    u'm': 895,
    u'ｯ': 500,
    u'q': 602,
    u'ｳ': 500,
    u'u': 582,
    u'ｷ': 500,
    u'y': 570,
    u'ｻ': 500,
    u'}': 449,
    u'ｿ': 500 }
widthsByUnichar['HYSMyeongJo-Medium'] = {
    u' ': 333,
    u'$': 625,
    u'(': 500,
    u',': 291,
    u'0': 625,
    u'4': 625,
    u'8': 625,
    u'<': 833,
    u'D': 750,
    u'H': 791,
    u'L': 666,
    u'P': 666,
    u'T': 791,
    u'X': 708,
    u'\\': 375,
    u'`': 333,
    u'd': 583,
    u'h': 583,
    u'l': 291,
    u'p': 583,
    u't': 375,
    u'x': 625,
    u'|': 583,
    u'#': 833,
    u"'": 250,
    u'+': 833,
    u'/': 375,
    u'3': 625,
    u'7': 625,
    u';': 333,
    u'?': 500,
    u'C': 708,
    u'G': 750,
    u'K': 791,
    u'O': 750,
    u'S': 666,
    u'[': 500,
    u'_': 500,
    u'c': 541,
    u'g': 583,
    u'k': 583,
    u'o': 583,
    u's': 541,
    u'w': 833,
    u'{': 583,
    u'"': 416,
    u'&': 833,
    u'*': 500,
    u'.': 291,
    u'2': 625,
    u'6': 625,
    u':': 333,
    u'>': 916,
    u'B': 708,
    u'F': 666,
    u'J': 500,
    u'N': 791,
    u'R': 708,
    u'V': 750,
    u'Z': 666,
    u'^': 500,
    u'b': 583,
    u'f': 375,
    u'j': 333,
    u'n': 583,
    u'r': 458,
    u'v': 583,
    u'z': 500,
    u'~': 750,
    u'!': 416,
    u'%': 916,
    u')': 500,
    u'-': 833,
    u'1': 625,
    u'5': 625,
    u'9': 625,
    u'=': 833,
    u'A': 791,
    u'E': 708,
    u'I': 375,
    u'M': 916,
    u'Q': 750,
    u'U': 791,
    u'Y': 708,
    u']': 500,
    u'a': 541,
    u'e': 583,
    u'i': 291,
    u'm': 875,
    u'q': 583,
    u'u': 583,
    u'y': 625,
    u'}': 583 }
widthsByUnichar['STSong-Light'] = {
    u' ': 207,
    u'$': 462,
    u'(': 374,
    u',': 238,
    u'0': 462,
    u'4': 462,
    u'8': 462,
    u'<': 605,
    u'@': 748,
    u'D': 739,
    u'H': 793,
    u'L': 526,
    u'P': 544,
    u'T': 607,
    u'X': 647,
    u'\\': 333,
    u'`': 239,
    u'd': 529,
    u'h': 518,
    u'l': 228,
    u'p': 524,
    u't': 277,
    u'x': 466,
    u'|': 258,
    u'#': 467,
    u"'": 239,
    u'+': 605,
    u'/': 334,
    u'3': 462,
    u'7': 462,
    u';': 238,
    u'?': 344,
    u'C': 695,
    u'G': 729,
    u'K': 666,
    u'O': 772,
    u'S': 465,
    u'W': 972,
    u'[': 374,
    u'_': 500,
    u'c': 427,
    u'g': 444,
    u'k': 495,
    u'o': 524,
    u's': 336,
    u'w': 652,
    u'{': 370,
    u'"': 342,
    u'&': 710,
    u'*': 423,
    u'.': 238,
    u'2': 462,
    u'6': 462,
    u':': 238,
    u'>': 605,
    u'B': 560,
    u'F': 511,
    u'J': 312,
    u'N': 758,
    u'R': 628,
    u'V': 711,
    u'Z': 607,
    u'^': 606,
    u'b': 503,
    u'f': 264,
    u'j': 230,
    u'n': 527,
    u'r': 338,
    u'v': 450,
    u'z': 407,
    u'~': 605,
    u'!': 270,
    u'%': 797,
    u')': 374,
    u'-': 375,
    u'1': 462,
    u'5': 462,
    u'9': 462,
    u'=': 605,
    u'A': 684,
    u'E': 563,
    u'I': 318,
    u'M': 896,
    u'Q': 772,
    u'U': 753,
    u'Y': 620,
    u']': 374,
    u'a': 417,
    u'e': 415,
    u'i': 241,
    u'm': 793,
    u'q': 504,
    u'u': 517,
    u'y': 452,
    u'}': 370 }
widthsByUnichar['HeiseiMin-W3'] = {
    u'ﾁ': 500,
    u'̂': 333,
    u'ﾅ': 500,
    u'̆': 333,
    u'ﾉ': 500,
    u'̊': 333,
    u'ﾍ': 500,
    u'ﾑ': 500,
    u'ﬂ': 556,
    u'ﾕ': 500,
    u'ﾙ': 500,
    u'ﾝ': 500,
    u' ': 250,
    u'£': 500,
    u'™': 980,
    u'$': 500,
    u'(': 333,
    u'«': 500,
    u',': 250,
    u'¯': 333,
    u'0': 500,
    u'³': 300,
    u'̲': 500,
    u'4': 500,
    u'·': 250,
    u'8': 500,
    u'»': 500,
    u'<': 564,
    u'¿': 444,
    u'@': 921,
    u'Ã': 722,
    u'ł': 278,
    u'D': 722,
    u'Ç': 667,
    u'H': 722,
    u'Ë': 611,
    u'L': 611,
    u'Ï': 333,
    u'P': 556,
    u'Ó': 722,
    u'Œ': 889,
    u'T': 611,
    u'X': 722,
    u'Û': 722,
    u'\\': 278,
    u'ß': 500,
    u'､': 500,
    u'`': 333,
    u'ã': 444,
    u'｢': 500,
    u'd': 500,
    u'ç': 444,
    u'ｦ': 500,
    u'h': 500,
    u'ë': 444,
    u'ｪ': 500,
    u'l': 278,
    u'ï': 278,
    u'ｮ': 500,
    u'p': 500,
    u'ó': 500,
    u'ｲ': 500,
    u't': 278,
    u'ｶ': 500,
    u'x': 500,
    u'û': 500,
    u'ｺ': 500,
    u'|': 200,
    u'ÿ': 500,
    u'ž': 444,
    u'́': 333,
    u'ﾂ': 500,
    u'̅': 500,
    u'ﾆ': 500,
    u'ﾊ': 500,
    u'ﾎ': 500,
    u'–': 500,
    u'ﾒ': 500,
    u'ﾖ': 500,
    u'ﾚ': 500,
    u'ﾞ': 500,
    u'#': 500,
    u'¤': 500,
    u"'": 180,
    u'›': 333,
    u'+': 564,
    u'¬': 564,
    u'/': 278,
    u'ı': 278,
    u'3': 500,
    u'7': 500,
    u'¸': 333,
    u';': 278,
    u'¼': 750,
    u'?': 444,
    u'Ł': 611,
    u'À': 722,
    u'C': 667,
    u'Ä': 722,
    u'G': 722,
    u'È': 611,
    u'K': 722,
    u'Ì': 333,
    u'O': 722,
    u'Ð': 722,
    u'S': 556,
    u'•': 350,
    u'Ô': 722,
    u'W': 944,
    u'ｸ': 500,
    u'Ø': 722,
    u'[': 333,
    u'Ü': 722,
    u'_': 500,
    u'š': 389,
    u'à': 444,
    u'c': 444,
    u'･': 500,
    u'ä': 444,
    u'g': 500,
    u'ｩ': 500,
    u'è': 444,
    u'k': 500,
    u'ｭ': 500,
    u'ì': 278,
    u'o': 500,
    u'ｱ': 500,
    u'ð': 500,
    u's': 389,
    u'ｵ': 500,
    u'ô': 500,
    u'w': 722,
    u'ｹ': 500,
    u'ø': 500,
    u'{': 480,
    u'ｾ': 500,
    u'Ž': 611,
    u'ü': 500,
    u'̀': 333,
    u'ﾃ': 500,
    u' ': 500,
    u'̄': 333,
    u'ﾇ': 500,
    u'̈': 333,
    u'ﾋ': 500,
    u'̌': 333,
    u'ﾏ': 500,
    u'ﾓ': 500,
    u'‒': 500,
    u'ﾗ': 500,
    u'ﾛ': 500,
    u'‚': 333,
    u'ﾟ': 500,
    u'„': 444,
    u'¡': 333,
    u'"': 408,
    u'¥': 500,
    u'&': 778,
    u'©': 760,
    u'̨': 333,
    u'*': 500,
    u'­': 564,
    u'.': 250,
    u'￨': 500,
    u'2': 500,
    u'µ': 500,
    u'6': 500,
    u'¹': 300,
    u':': 278,
    u'½': 750,
    u'>': 564,
    u'Á': 722,
    u'｡': 500,
    u'B': 667,
    u'Å': 722,
    u'F': 556,
    u'É': 611,
    u'J': 389,
    u'Í': 333,
    u'N': 722,
    u'Ñ': 722,
    u'‾': 500,
    u'R': 667,
    u'Õ': 722,
    u'V': 722,
    u'Ù': 722,
    u'Z': 611,
    u'Ý': 722,
    u'^': 469,
    u'á': 444,
    u'Š': 556,
    u'b': 500,
    u'å': 444,
    u'‹': 333,
    u'f': 333,
    u'é': 444,
    u'ｨ': 500,
    u'j': 278,
    u'í': 278,
    u'ｬ': 500,
    u'n': 500,
    u'ñ': 500,
    u'ｰ': 500,
    u'r': 333,
    u'õ': 500,
    u'ｴ': 500,
    u'v': 500,
    u'ù': 500,
    u'Ÿ': 722,
    u'z': 444,
    u'ý': 500,
    u'ｼ': 500,
    u'~': 333,
    u'ﾀ': 500,
    u'̃': 333,
    u'ﾄ': 500,
    u'̇': 333,
    u'ﾈ': 500,
    u'̋': 333,
    u'ﾌ': 500,
    u'‑': 333,
    u'ﾐ': 500,
    u'ﾔ': 500,
    u'ﾘ': 500,
    u'ﾜ': 500,
    u'⁄': 167,
    u'!': 333,
    u'¢': 500,
    u'%': 833,
    u'̧': 333,
    u'¦': 200,
    u')': 333,
    u'ª': 276,
    u'-': 333,
    u'®': 760,
    u'1': 500,
    u'²': 300,
    u'5': 500,
    u'9': 500,
    u'º': 310,
    u'=': 564,
    u'¾': 750,
    u'A': 722,
    u'ǀ': 200,
    u'Â': 722,
    u'E': 611,
    u'Æ': 889,
    u'I': 333,
    u'Ê': 611,
    u'M': 889,
    u'Î': 333,
    u'Q': 722,
    u'œ': 722,
    u'Ò': 722,
    u'U': 722,
    u'Ö': 722,
    u'Y': 722,
    u'ﬁ': 556,
    u'Ú': 722,
    u']': 333,
    u'Þ': 556,
    u'a': 444,
    u'｣': 500,
    u'â': 444,
    u'e': 444,
    u'ｧ': 500,
    u'æ': 667,
    u'i': 278,
    u'ｽ': 500,
    u'ｫ': 500,
    u'ê': 444,
    u'm': 778,
    u'ｯ': 500,
    u'î': 278,
    u'q': 500,
    u'ｳ': 500,
    u'ò': 500,
    u'u': 500,
    u'ｷ': 500,
    u'ö': 500,
    u'y': 500,
    u'ｻ': 500,
    u'ú': 500,
    u'}': 480,
    u'ｿ': 500,
    u'þ': 500 }
widthsByUnichar['HYGothic-Medium'] = {
    u' ': 500,
    u'$': 500,
    u'(': 500,
    u',': 500,
    u'0': 500,
    u'4': 500,
    u'8': 500,
    u'<': 500,
    u'@': 500,
    u'D': 500,
    u'H': 500,
    u'L': 500,
    u'P': 500,
    u'T': 500,
    u'X': 500,
    u'\\': 500,
    u'`': 500,
    u'd': 500,
    u'h': 500,
    u'l': 500,
    u'p': 500,
    u't': 500,
    u'x': 500,
    u'|': 500,
    u'#': 500,
    u"'": 500,
    u'+': 500,
    u'/': 500,
    u'3': 500,
    u'7': 500,
    u';': 500,
    u'?': 500,
    u'C': 500,
    u'G': 500,
    u'K': 500,
    u'O': 500,
    u'S': 500,
    u'W': 500,
    u'[': 500,
    u'_': 500,
    u'c': 500,
    u'g': 500,
    u'k': 500,
    u'o': 500,
    u's': 500,
    u'w': 500,
    u'{': 500,
    u'"': 500,
    u'&': 500,
    u'*': 500,
    u'.': 500,
    u'2': 500,
    u'6': 500,
    u':': 500,
    u'>': 500,
    u'B': 500,
    u'F': 500,
    u'J': 500,
    u'N': 500,
    u'R': 500,
    u'V': 500,
    u'Z': 500,
    u'^': 500,
    u'b': 500,
    u'f': 500,
    u'j': 500,
    u'n': 500,
    u'r': 500,
    u'v': 500,
    u'z': 500,
    u'!': 500,
    u'%': 500,
    u')': 500,
    u'-': 500,
    u'1': 500,
    u'5': 500,
    u'9': 500,
    u'=': 500,
    u'A': 500,
    u'E': 500,
    u'I': 500,
    u'M': 500,
    u'Q': 500,
    u'U': 500,
    u'Y': 500,
    u']': 500,
    u'a': 500,
    u'e': 500,
    u'i': 500,
    u'm': 500,
    u'q': 500,
    u'u': 500,
    u'y': 500,
    u'}': 500 }
message1 = '\x82\xb1\x82\xea\x82\xcd\x95\xbd\x90\xac\x96\xbe\x92\xa9\x82\xc5\x82\xb7\x81B'
message2 = '\x82\xb1\x82\xea\x82\xcd\x95\xbd\x90\xac\x8ap\x83S\x83V\x83b\x83N\x82\xc5\x82\xb7\x81B'
