# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

from gettext import gettext as _
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4 import uic
from aptsources.sourceslist import SourceEntry
UIDIR = '/home/jr/src/software-properties/deneutral'

class DialogEdit(QDialog):
    
    def __init__(self, parent, sourceslist, source_entry, datadir):
        QDialog.__init__(self, parent)
        self.sourceslist = sourceslist
        self.source_entry = source_entry
        uic.loadUi('%s/designer/dialog_edit.ui' % datadir, self)
        self.combobox_type.addItem(_('Binary'))
        self.combobox_type.addItem(_('Source code'))
        if source_entry.type == 'deb':
            self.combobox_type.setCurrentIndex(0)
        elif source_entry.type == 'deb-src':
            self.combobox_type.setCurrentIndex(1)
        else:
            print "Error, unknown source type: '%s'" % source_enrty.type
        self.entry_uri.setText(source_entry.uri)
        self.entry_dist.setText(source_entry.dist)
        comps = ''
        for c in source_entry.comps:
            if len(comps) > 0:
                comps = comps + ' ' + c
                continue
            comps = c
        
        self.entry_comps.setText(comps)
        self.entry_comment.setText(source_entry.comment)
        self.connect(self.entry_uri, SIGNAL('textChanged(const QString&)'), self.check_line)
        self.connect(self.entry_dist, SIGNAL('textChanged(const QString&)'), self.check_line)
        self.connect(self.entry_comps, SIGNAL('textChanged(const QString&)'), self.check_line)
        self.connect(self.entry_comment, SIGNAL('textChanged(const QString&)'), self.check_line)

    
    def check_line(self, text):
        """Check for a valid apt line and set the enabled value of the
       button 'add' accordingly"""
        line = self.get_line()
        self.button_edit_ok = self.buttonBox.button(QDialogButtonBox.Ok)
        if line == False:
            self.button_edit_ok.setEnabled(False)
            return None
        
        source_entry = SourceEntry(line)
        if source_entry.invalid == True:
            self.button_edit_ok.setEnabled(False)
        else:
            self.button_edit_ok.setEnabled(True)

    
    def get_line(self):
        '''Collect all values from the entries and create an apt line'''
        if self.source_entry.disabled == True:
            line = '#'
        else:
            line = ''
        if self.combobox_type.currentIndex() == 0:
            line = line + 'deb'
        else:
            line = line + 'deb-src'
        text = unicode(self.entry_uri.text())
        if len(text) < 1 and text.find(' ') != -1 or text.find('#') != -1:
            return False
        
        line = line + ' ' + text
        text = unicode(self.entry_dist.text())
        if len(text) < 1 and text.find(' ') != -1 or text.find('#') != -1:
            return False
        
        line = line + ' ' + text
        text = unicode(self.entry_comps.text())
        if text.find('#') != -1:
            return False
        elif text != '':
            line = line + ' ' + text
        
        text = unicode(self.entry_comment.text())
        if text != '':
            line = line + ' #' + text + '\n'
        else:
            line = line + '\n'
        return line

    
    def run(self):
        result = self.exec_()
        if result == QDialog.Accepted:
            line = self.get_line()
            index = self.sourceslist.list.index(self.source_entry)
            file = self.sourceslist.list[index].file
            self.sourceslist.list[index] = SourceEntry(line, file)
        
        return result


