# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

import unittest
import sqlite3 as sqlite

class RegressionTests(unittest.TestCase):
    
    def setUp(self):
        self.con = sqlite.connect(':memory:')

    
    def tearDown(self):
        self.con.close()

    
    def CheckPragmaUserVersion(self):
        cur = self.con.cursor()
        cur.execute('pragma user_version')

    
    def CheckPragmaSchemaVersion(self):
        con = sqlite.connect(':memory:', detect_types = sqlite.PARSE_COLNAMES)
        
        try:
            cur = self.con.cursor()
            cur.execute('pragma schema_version')
        finally:
            cur.close()
            con.close()


    
    def CheckStatementReset(self):
        con = sqlite.connect(':memory:', cached_statements = 5)
        cursors = [ con.cursor() for x in xrange(5) ]
        cursors[0].execute('create table test(x)')
        for i in range(10):
            []([], [ (x,) for x in xrange(10) ])
        
        for i in range(5):
            cursors[i].execute(' ' * i + 'select x from test')
        
        con.rollback()

    
    def CheckColumnNameWithSpaces(self):
        cur = self.con.cursor()
        cur.execute('select 1 as "foo bar [datetime]"')
        self.failUnlessEqual(cur.description[0][0], 'foo bar')
        cur.execute('select 1 as "foo baz"')
        self.failUnlessEqual(cur.description[0][0], 'foo baz')



def suite():
    regression_suite = unittest.makeSuite(RegressionTests, 'Check')
    return unittest.TestSuite((regression_suite,))


def test():
    runner = unittest.TextTestRunner()
    runner.run(suite())

if __name__ == '__main__':
    test()

